SBuilderX is a scenery creation tool for FSX

Introduction to SBuilderX


What is New in SBuilderX 3.13

If you never used SBuilderX before, please read all the Help documentation.

This is an important revision of SBuilderX since version 3.10 was released. There are many major and minor changes. The major improvements are listed below.

Object Library Manager

Append Object BGL/XML files

Append Land/Water Class RAW images

Polygon Slicing to QMID grid

Extrusion Bridge Lines

Textured Lines, Flat and Standing

MDL file placement

Lines of Objects

Taxiway Sign Objects

Generic Building Creation


Copyright Notice

SBuilderX is copyright © 2009 Luis Sá & PTSim. SBuilderX can be posted, distributed or made available for download providing that its original MSI file is not modified. You can use SBuilderX in freeware scenery projects providing that you make a statement in the documentation of your project similar to this one: "SBuilderX, was used in the making of ". In order to use SBuilderX in a commercial project you need to contact ptsim@ptsim.com .

SBuilderX can be supplied to you with third party Plug-Ins that add the capacity to use background images downloaded from the Internet. If you use any of such Plug-Ins, you agree to comply with all applicable terms and conditions that such images may hold.

Commercial License

The use of SBuilderX is free for non-commercial projects. If you want to use SBuilderX in commercial projects, you must contact ptsim@ptsim.com .


Installation

You need to run the installer (SBuilderX313.msi) before using SBuilderX. All needed files are included. You can keep your existing SBuilderX installation providing that you supply a target installation folder that is different from the present one. The installer reads the Windows Registry to find the locations of FSX and FSX SDK. If it can not find these programmes a window appears and you can manually indicate the locations of FSX and FSX SDK. To uninstall SBuilderX, please use the Windows Control Panel. SBuilderX was tested under Windows XP and Windows Vista (32 and 64 bit)

You can use Windows Explorer to inspect the folders created by the installer. If you are an advanced user you will probably look to some of these folders very often. In particular there is a folder that we refer to as ../SBuilderX/Tools/Work where many intermediate files are created when you generate scenery. When you run the installer to remove SBuilderX, these files are not deleted. Therefore, to completely remove SBuilderX from your system, you need to delete these files manually.

In addition to SBuilderX, two extra tools are installed: GetTiles and TilesCache . These tools are described in the Appendix.


Requirements

SBuilderX requires that certain programs be installed without which it will not function correctly.

Software

  • Flight Simulator X must be correctly installed and exist in the Registry.
  • The Flight Simulator X S.D.K. (Software Development Kit) must be installed so that SBuilderX can access its various tools.

Note: SBuilderX will not stop working if Flight Simulator X is not present in the system. You can, for example, place macros, place FS9 Library objects, place textured lines or polygons or getting maps for your reference.

Hardware

The complexity of your project will determine the requirements of SBuilderX. Essentially, if you use very large bitmaps as backgrounds or Maps, then you will need a lot of available memory, and if your project contains many elements, then processor speed will be important. In all case, the only limiting factor for SBuilderX will be the hardware.

Very Important Note: SBuilderX works best if your decimal separator is the character "." (point). If you have the decimal separator defined as comma (as it is the case in Portugal) and you note that SBuilderX will read/write wrong values, it is advisable to change the decimal character to "." (normal setting in most regions) through the Windows Control Panel.

Also very important note: a mouse with a wheel is almost mandatory to work with SBuilderX.


Acknowledgments

I would like to express my gratitude to Luis Féliz-Tirado without whom many additions in this present edition were not possible. His tutorials, his carefully testing, his positive criticism and even is help in putting together many files of this program, are most appreciated. SBuilderX also benefited from the support of many FSX experts. Here is an incomplete list: Richard Ludowise, Scott Smart, Ian Gallacher, Lance Tucker, Mischa, Don Grovestine and Arno Gerretsen. I am also grateful to Manfred Moldenhauer for Scasm, Pete Dowson for FSUIPC, Paul Henty for FsuipcClient, Jon Masterson for jmBglLib, and to the authors of the “Shapelib” software. Finally, I would like to thank the Microsoft FSX Aces Team for making FSX.

Luis Vieira de Sá, July, 2009


SBuilderX is a scenery creation tool for FSX

Working with SBuilderX


Manipulating the Display

The SBuilderX workspace is where you will do most of your design. Presently, the maximum size of this space is 1792x1280 pixels and it will contain the elements of your project that are visible. You can pan and zoom the workspace in order to see a greater area or more detail.

The first thing that you need to learn in order to work with SBuilderX is how to use the mouse to control the display. If you are experimenting with SBuilderX for the first time we recommend that you press New on the Toolbar and then practice using the mouse.

The easiest way to manipulate the display is with the Mouse Wheel. You perform 2 basic functions with the Mouse Wheel: Zooming and Panning.

You can zoom in or zoom out by turning the wheel in or out. On the other hand you can move (pan) the viewpoint by pressing down the mouse wheel and drag (e.g. moving the mouse while maintaining the wheel pressed down). When you want to move the viewpoint to a very distant location it is better that you zoom out first and pan afterwards.

Zoom and Pan do not change the position of lines, polygons or objects of your project. The cursor in Scenery Builder X will indicate in which mode you are and, after some time, you will get used to it.

If you do not have a mouse wheel, you can pan with the mouse by pressing P ( and holding) while you drag the display with the left mouse button. In the same way, you can Zoom In and Out with the mouse by pressing Z (and holding) while you move the mouse to the top or to the button of the display with the left mouse button pressed.


Status Bar

It is important that you understand the meaning of the parameters shown in the Status Bar.

Zoom - This is the amount of zoom displayed. You can zoom in and out with the mouse wheel. The minimum zoom level is 0 and displays the entire world. If you have Background turned on (View Menu - Show Background), an image of the Earth will display in zoom levels 0,1, and 2. Maximum zoom level is 25, but aerial images obtained through the image server function will only display up to their maximum level available in the SBuilderX tile cache.

Latitude - Longitude - This is the position of your cursor and will change as you move it over the workspace. You can change the display from Decimal Degrees to Degrees-Minutes-Seconds by modifying the SBuilder ini file (in the SBuilderX root folder.)

Tile - This is the name of the aerial image tile under the cursor and indicates its zoom level and x and y coordinates. These tiles are cached in the SBuilderX\Tiles directory. To find the absolute path to a tile, position the cursor over it, right click, and select Tile Path to Clipboard from the menu. You can then paste the path in an Explorer window to find the tile.

Dir - The default Flight Simulator X scenery files are located in numbered folders within the main Scenery folder. This number is indicated here and corresponds to the location of the cursor in the workspace.

File - The default airport (APX), bridge (BRX), vector terrain (CVX), and object (OBX) files are located in bgl files with this number and the respective prefix. This file number will change as you move the location of the cursor over the workspace.

QMID (L,U,V) - If you have the QMID (Quad Mesh Identifier) grid turned on (View - QMID Grid), these numbers will indicate the quad level as well as the U,V coordinates for that level at the location of the cursor. (The U,V,W vector space is the functional equivalent of the Cartesian X,Y,Z coordinate system.)

New function: To find the absolute path to a tile, position the cursor over it, right click, and select Tile Path to Clipboard from the menu. You can then paste the path in an Explorer window to find the tile.


Toolbar

Many of the functions of the toolbar can also be found in the various menu items.

- New Project
- Open Project
- Save Project
- Undo
- Pointer mode
- Zoom
- Land Class tool
- Water Class tool
- Line tool
- Polygon tool
- Object tool
- Exclude tool
- BGL Compile


Context-sensitive Menus

When you right click on the workspace, a pop-up menu will appear depending on the tool or mode selected.

Pointer mode

When the pointer is selected, this menu will appear:

1. The first line indicates the name of your project and is taken from the Project Properties window (File - Properties).

2. Center - selecting this will center the workspace on the pointer location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the pointer in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Properties - if no scenery element is selected, this will call up the Project Properties window. If a scenery element has been selected, then the Properties window for that element will display.

Map

If a Map is selected, then this will be the menu if you right-click on the edge of the Map:

1. The first line indicates the name of the Map.

2. Center - selecting this will center the workspace on the pointer location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the pointer in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - select this to delete the Map.

7. Calibrate - this will take you directly to the Point Calibration window for that Map.

8. Properties - this will call up the Map Properties window.

Land Class Tool

If the land class tool is selected, this menu will display if you right-click on the land class assignment:

1. If the cursor is located over a land class assignment, the first line will indicate the land class value.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - selecting this will delete the land class assignment under the cursor.

Water Class Tool

If the water class tool is selected, this menu will display if you right-click on the water class assignment:

1. If the cursor is located over a water class assignment, the first line will indicate the water class value.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - selecting this will delete the water class assignment under the cursor.

Line Tool

If the line tool is selected, this menu will display if you right-click on the line:

1. The first line indicates the name and the index of the line.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - selecting this will delete the line.

7. Set Width ... - this will take you to the dialogue where you can set the width of the line.

8. Set Altitude ... - this will open the dialogue where you set the altitude of the line.

9. Set Transparency ... - you can choose the color of the line as well as the transparency of that color.

10. Slice to QMID(x) - if you display the QMID grid, you can slice the line into different parts at the limits of the displayed grid.

11. Make Poly - you can add a polygon using the line as a basis; SBuilderX will close the line to make the polygon, in addition to the line.

12. Convert to Poly - this will replace the line by a polygon; the line width will become the polygon width.

13. Smooth ... - you can smooth the curves of the line using an interpolation function.

14. Sample ... - this will delete points in the line using a distance function.

15. Manual Check ... - with this function, you can navigate through and select each individual point in a line, and go from line to line.

16. Properties - this will call up the Line Properties window.

Line Point

By selecting a point on a line, this menu will appear if you right-click on the point:

1. The first line indicates the index of the point and the name of the line.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Point from Aircraft - if Flight Simulator X is launched, you can get the point location and altitude from FS.

5. Zoom In- increases the zoom level.

6. Zoom Out - decreased the zoom level.

7. Delete - select this to delete the Map.

8. Properties - this will call up the Point Properties window.

Polygon Tool

If the polygon tool is selected, this menu will display if you right-click on the edge of the polygon:

1. The first line indicates the name and index of the polygon.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - this will delete the polygon.

7. Set Altitude ... - this will open the dialogue where you set the altitude of the polygon.

8. Set Transparency ... - you can choose the color of the polygon as well as the transparency of that color.

9. Make Line - this will add a line based on the outline of the polygon; SBuilderX will not close the line.

10. Fill to QMID13 - you can force the polygon to fill the entire QMID level 13 grid.

11. Slice to QMID13 - you can slice the polygon into parts at the limits of the QMID level 13 grid..

12. Smooth ... - you can smooth the curves of the polygon using an interpolation function.

14. Sample ... - this will delete points in the polygon using a distance function.

15. Manual Check ... - with this function, you can navigate through and select each individual point in a polygon, and go from polygon to polygon.

16. Properties - this will call up the Polygon Properties window.

Object Tool

If the object tool is selected, this menu will display if you right-click on the object:

1. The first line indicates the index of the object.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - select this to delete the object.

7. Properties - this will call up the Object Properties window.

Exclusion Tool

If the exclusion tool is selected, this menu will display if you right-click on the edge of the exclusion:

1. The first line indicates the index of the exclusion.

2. Center - selecting this will center the workspace on the cursor location.

3. Fly Aircraft Here - if Flight Simulator X is launched, selecting this item will place the user aircraft on the location of the cursor in SBuilderX.

4. Zoom In- increases the zoom level.

5. Zoom Out - decreased the zoom level.

6. Delete - select this to delete the exclusion.

7. Properties - this will call up the Exclusion Properties window.


Working with Points, Lines and Polygons

  • Creating a Line
  • Accessing the properties of a Point in a Line
  • Selecting, moving and deleting Points
  • Selecting and moving the whole Line
  • Holding I - D - B and clicking
  • Polygons are very similar to Lines
  • Joining Lines and Polygons
  • Set Width
  • Set Altitude
  • Make Poly
  • Convert to Poly
  • Make Line
  • Smooth
  • Sample
  • Manual Check

Creating a Line

Select the Line tool on the Tool bar to start the creation of a Line. You will be creating your first Line with SBuilderX. As soon as you press the Left Mouse, one point (the first point) of your Line is created. You can add more points by pressing the Left Mouse several times. To terminate the Line press the Right Mouse.

Accessing the properties of a Point in a Line

Once you have created a Line you can click with the right mouse over one point of the Line to have access to its Properties. Note that you need to click exactly over a point. If you click on a segment of the Line you will get the properties of the Line, not the properties of a point in that Line.

By selecting Properties, you can go to the Point Properties window.

If you select Point from Aircraft from the context menu, the altitude of the point will be set to the aircraft altitude in Flight Simulator.

Selecting, moving and deleting Points

Click with the Left Mouse over a point and hold to enter in Move mode. You note that the point changes its colour reflecting the fact that it became Selected. After selecting one point, you can press and hold the SHIFT key and click over a second point with the Left Mouse. If you do it correctly you will get 2 Selected points. You can move the 2 points simultaneously. Or you can delete the points by pressing the DELETE key. When you press the DELETE key a dialog box appears and you are asked to confirm deletion of selected parts.

Selecting and moving the whole Line

If you click with the Left Mouse on the segment of a Line you select the whole Line. Then you can move it (dragging with the mouse), delete it, copy it, paste it, etc. If you click with the Right Mouse on the segment of a Line you get access to its Properties.

Holding I - D - B and clicking

You can work very fast with Lines by pressing and holding the keys I, D, or B while you click on points of Lines:

  • hold the I key (I for insert) and click with the Left Mouse on a segment of a Line to Insert a new point.
  • hold the D key (D for delete) and click with the Left Mouse over a point of a Line to Delete the point.
  • hold the B key (B for break) and click with the Left Mouse over a segment of a Line to Break it into 2 parts.
If you press (and release) the INSERT key while you are in Line (or Poly) mode you will enter a special insert mode. In this mode, you will insert a new point whenever you click in a segment of a Line. If you want to exit from this mode you will need to press the mouse right button or the ESC key. This special inserting mode is very important to speed up some tasks.

Polygons are very similar to Lines

You can create a Polygon in a similar manner to a Line. You need to change to Polygon mode by pressing the Poly button in the Tool bar. Note that to terminate the construction of a Polygon you press the Right Mouse. You can use the I and D keys to insert and to delete points but you can not break Polygons.

Note that when you are in Polygon Mode (the Poly button in the Tool bar is pressed) you cannot select Lines that may exist in the project. However, if you change the mode to Pointer Mode you can work with Lines and Polygons simultaneously. You can, for example, select some points of one Line and some other points of a Polygon and move (or delete) them simultaneously. Note that in Pointer Mode you can not Copy, Cut or Paste. These Edit functions only work in Polygon and Line Modes. Also note that when you paste a Line or a Polygon, the created Line or Polygon will cover the previously copied (or cut) Line or Polygon.

Joining Lines and Polygons

A Line has a Start (solid square) and an End (outlined square) Point.

You can Join 2 Lines by selecting one of the Lines and moving it so that the End Point of one of the Lines coincides with the Start Point of the other Line. By releasing the Lines in that position they will join and become a single Line.

You can join 2 Polygons if they share a common side with similar number of points.

.

There are different entries in the SBuilder.ini file related to this function:

1. AutoLinePolyJoin=True -- Lines and Polygons will be automatically joined when they are placed together and one is selected;
2. DisplayJoin=True -- Lines and Polygons will be joined as the display changes( for example, by zooming in or out);
3. NameJoin=True -- Lines and Polygons that have the same name will be joined.

You can make Polygons from Lines and Lines from Polygons. This can be useful in an handful of situations. For example you have a lake and you want to make a shoreline for the lake. The shoreline could be made as a Line generated from the Polygon. To achieve this, you have the button "Make Line" in the Polygon property window and the button "Make Poly" in the Line property window.

Set Width

Vector Lines (roads, shorelines, railroads) have a fixed width in FS that is defined in the terrain.cfg file. You can change the displayed width of these Lines in SBuilderX so that they are easier to see in your project, but this will not change the width of the terrain element in FS. You can also define the width of other types of Lines (for example, textured Lines) - just right-click on the Line segment and select Set Width... from the menu:

You can set the width of the entire Line (constant width) or of the Start and End Points. Be sure to press Set to confirm your changes. You can also reverse the direction of the Line in this dialogue.

If you wish to change the width at each individual Point, right-click on the Point and set its width in the Point Properties window:

Set Altitude

Vector Lines always cling to the altitude mesh and you cannot modify their height. But, you can set the altitude of textured Lines, of Lines of Objects, and of certain Polygons (Airport Flattens and Hydro Polygons). Right-click on the Line segment or on the edge of the Polygon and choose Set Altitude from the menu - make your changes in the Altitude dialogue:

In the case of a Hydro Polygon, you can also determine the slope.

Make Poly

You can use a Line as the basis for the creation of a Polygon. Select the Line tool and right-click on the Line for the menu, then select Make Poly.

SBuilderX will close the Line by adding a segment from the Start to the End Point and make a Polygon, in addition to the Line.

You can then select the Polygon and assign its Properties.

Convert to Poly

You can convert a Line to a Polygon that has the same shape and width as the Line. Make sure that the Line first has the desired width:

Then select the Line tool, right-click on the Line to get the menu and select Convert to Poly:

SBuilderX will create a Polygon that will replace the Line:

Make Line

You can also create a Line from a Polygon. Select the Polygon tool and right-click on the edge of the Polygon for the menu. Select Make Line:

SBuilderX will create a Line in addition to the Polygon. If you turn off the display of Polygons, you will see the Line:

Smooth

If your Line or Polygon has too many angles, you can automatically add more Points in order to make it smoother.

To smooth a Line, select the Line tool, right-click on the Line segment, not the Point, and choose Smooth...

You will get the Smooth dialogue where you can choose a few options:

Each time you press Smooth, more points will be inserted. When you are satisfied with the result, click OK.

To Smooth a Polygon, the procedure is similar. Select the Polygon tool, right-click on the edge of the Polygon, and choose Smooth... from the menu:

In the Smooth dialogue choose the desired options and values:

Press Smooth until you are satisfied with the results:

Sample

You can also automatically reduce the number of Points in Lines and Polygons using the Sample function.

For a Line, select the Line tool, right-click on the Line segment, not the Point, and choose Sample... :

In the Sample dialogue, indicate the required values and press Sample:

Click OK when sufficient Points have been removed:

For Polygons, select the Polygon tool, click on the edge of the Polygon, and select Sample... from the menu:

Indicate the values in the dialogue and press Sample:

When you are satisfied with the result, click OK:

Manual Check

If you wish to check each Point successively in the Line or Polygon, select Manual Check from the context menu:


Working with Objects

You can place a large variety of objects with SBuilderX, including:
  • all FS X and FS 9 library objects
  • MDL files that are not in an object library
  • Generic Buildings
  • API macros
  • RWY12 objects
  • Taxiway signs
  • Windsocks
  • Beacons
  • Effects

Select the Object tool from the Tool bar and click in the workspace on the location where you want to place the object. The Object Properties window will display:

You can indicate the general properties of the object such as coordinates, orientation, and complexity, as well as modify the display name of the object. Select the type of object that you want to place from the list and SBuilderX will display the appropriate tab from which to choose the object..

Once you have placed the object, you will see a placeholder in the SBuilderX workspace. If you are in Object mode (if the Object tool is selected), you can rotate the object with the mouse by clicking and dragging with the rotate cursor. When the object is facing due North, the central line will point straight up:

Library Object

On the Library Object tab, you can select the specific library category from which to choose your object:

You can update the object with new values for Length, Width and Scale for that particular object - just change the values in the respective fields and click OK.

If there is a screenshot of the object, it will display. For a larger image, click on the thumbnail image. If there is no image, you can capture a screenshot from FS if it is running. Simply right-click on the image area and SBuilderX will switch to the Flight Simulator display. Draw a selection rectangle around the object in FS and press the Space bar to capture the screenshot. It will then be placed within the LibObjects folder and automatically associated with that object entry in SBuilderX.

Object Libraries are defined in lists, text files that can be found in the LibObjects folder. Each text file should have the name of the library and contain the list of objects for that library in the following format:
- the first line should be the name of the library within brackets, e.g. [FSX_buildings]
- each successive line should have the
1. GUID of the object,
2. the placement type indicated by either 0 (FS 8 techniques), 1 (placed with SCASM), or 2 (placed with FS X BGLComp),
3. the width and length of the object - this will determine the footprint of the object placeholder in SBuilderX,
4. the scale of the object, usually 1.
Each of these entries should be separated by a single space.

Here is an example:
[FSX_buildings]
{396f4b4a-a82d-4ae8-a362-0b1481a72703} 2 118.33 127.74 1 BLD_Hotel_Trop_Hirise_01

In addition, there is a master objects.txt file that contains the list of all the object library lists that should be available in the LibObjects tab. You can add object library lists to this file with an include statement, such as:
include=FSX_buildings.txt

Please see the explanation at the top of the objects.txt file for more details.

MDL files

You can place MDL files exported from gMax or 3d Studio Max with the FS 9 or FS X game packs, even if they have not been placed in an object library bgl. Select MDL from the list in the General tab and indicate the desired MDL file:

SBuilderX will import the MDL file, display the Width and Length as well as the GUID. When you compile your project, SBuilderX will create an object library bgl with that MDL and its placement information. You must remember to copy the required textures to the local scenery folder.

Generic Buildings

SBuilderX can also place all Generic Buildings, including the recent FS 9 and FS X high-resolution hangar and terminal buildings. Select the Building type on the General tab to go to the Gen Buildings tab:

In the top part of the tab, you can choose the building type and width and depth.

In the bottom part of the tab, you can store buildings that already exist in Flight Simulator or that you have created for your use. To store a default building from Flight Simulator, you must first append an object bgl containing the building (File-Append-Object BGL/XML). After the bgl has been decompiled and is displayed in SBuilderX, select the desired building, right-click to get the context menu, choose Properties. Give the building a descriptive name in the Object Name field, then click on Store. The building will appear in the list above any previously selected, stored building.

To load a previously stored building, select it from the list and click on Load.

To see more details concerning the building, as well as a preview, click on Detail.

For a larger preview image, click on the Preview window.

Buildings can have a bottom, window, and top section. If you do not want one or more sections in the building, set the height of that section to 0 meters.

The Flight Simulator textures display best in game when sections have heights of 5 meters or multiples of that. However, this may seem rather large - generally, residential buildings may really have only 3 meter heights per floor, and commercial buildings perhaps around 4 meters per floor.

There are various kinds of Generic Buildings:
- apartment buildings, British
- apartment buildings, French
- apartment buildings, German
- apartment buildings, default
- government buildings
- warehouses
- skyscrapers (office buildings)
- airport buildings
- bank buildings
- small airport terminals (FS 9/ FS X)
- medium airport terminals (FS 9/ FS X)
- large airport terminals (FS 9/ FS X)
- parking garage (FS 9/ FS X)
- small hangar (FS 9/ FS X)
- medium hangar (FS 9/ FS X)
- large hangar (FS 9/ FS X)

A complete list of texture numbers can be found in an appendix.

SBuilderX contains a list of stored buildings that covers most of the building types and textures available. You can either load the buildings for your own use, or modify their details if you prefer.

API Macros

To place a macro, select that Object Type in the General tab. This will display the Macros tab:

You can then select the category and macro object that you want to place, as well as modify any additional macro parameters.

You can add macro objects to your SBuilder projects. There are a number of available macro objects but you must remember that the objects use code for FS2002 and earlier versions of Flight Simulator. SBuilderX supports macros generated by FSDS (Flight Simulator Design Studio) in the API format (macros used in the Airport for Windows scenery design program). The bgl file compiled by SBuilderX can be used in FS X as well as previous versions of FS, since SCASM is used to generate these files.

Before you start using macros, you need to set the folders where SBuilderX looks for the macro objects that you are going to use. You set these folders through the Edit-Preferences menu. The folders must contains the macros and their pictures if you want them to be visible on the bottom left corner of the Macros window as shown above.

API Macros

Macro files for Airport have a standard file extension of ".API" and they are using a standard parameter set. Not all macros are using all parameters. That is why sometimes dummy values are passed to a macro.

The following is the first part of the file for the macro object shown above:

;CATEGORY General Objects
;MACRODESC Wind_Generator
;DEFAULTSCALE 0,10
;DEFAULTRANGE 5000 M
;DEFAULTDENSITY DENSE
;DESIGNSHAPELINES -10, -20, 10, -20, 10, -20, 10, 20, 10, 20, -10, 20,

; %1 Latitude
; %2 Longitude
; %3 Range
; %4 Scale
; %5 Heading
; %6 User
; %7 User
; %8 User
; %9 Shadow
; %10 V1 value
; %11 Elevation
; %12 Scenery complexity

The first thing that you should do is to place the images of the macros in the same file as the APIs. In the Airport for Windows program the images are in the Resources folder and the macros themselves are in the API folder. So we copy the images from the Resource folder into the API folder.

We can open the API using the EDIT command. If we do that and we change the first line
;CATEGORY API - Wind Turbines
and then save the API (note that the API file is a plain TXT file!) we will create a new category. If we add this extra line to all wind turbine macros, then if we close SBuilderX and start again, all of them get organized in a group.

RWY12 Objects

Rwy12 is a very popular and very easy program to place XML objects. A large number of objects is available and ready for use with Rwy12. You can place these objects in SBuilderX. If you have Rwy12 working then you only need to tell SBuilder where to look for it. To indicate the location of the Rwy12 folder, use the Edit-Preferences menu. You can choose the objects you want to place in the Rwy12 Objects tab:

Taxiway signs

You can also place taxiway signs with SBuilderX.

By clicking on the Make button, you can display the Build Sign window where you can put together the required types, symbols and characters for the label.

Windsocks

You can place the default FS windsocks too:

Beacons

Choose Beacon from the Object Type list to place a rotating beacon on your objects - please note that this will not place a tower or pylon, only the rotating beacon.

Effects

To place an effect, you must know the name and indicate any additional parameters (such as duration, etc.)


Working with Maps

Working in Scenery Builder is based on background Map sets. Background Maps guide you in the creation of shorelines, roads, rivers and so on, or they can be used to make photo-real ground tiles, or to create land classification files. If you are only making lines and polygons, you could, in principle, work without a background Map. However, for Photo scenery creation they are mandatory.

You can have several Map sets in your Project, but you must be aware that they require considerable amounts of system memory. Normally, you have only one Map set per project.

Each Map set is a composed of from1 up to 6 individual maps. The basic Map of a set is the Summer Map. The next 5 maps are the Spring, the Winter, the Hard Winter, the Fall, and the Night maps. If you only loaded a Summer Map and you specify, for example, Spring Photo output, the Summer map will be used instead of the missing Spring map.

A Map can be any image of your choice, including screenshots from Flight Simulator, digitized maps, imported GIS images, or aerial or satellite images. SBuilderX contains an image server function that can download maps from Yahoo Maps, or aerial images from various well-known Web servers.

Maps can have one of the following bitmap formats: 8-bit with a palette, 24-bit or 32-bit. In addition, Maps can be in the TIFF or GeoTIFF format, this last being particularly easy to use as it already contains all calibration information within the image file.

Although a Map can be selected and moved as any Point, Line or Polygon, Maps are supposed to be placed in their proper location to serve as a reference for the scenery work. It essential that you carefully calibrate your Map.

All Maps must be in the so-called Geographic projection using the WGS84 datum. (This is not, technically, a projection at all, but rather a simple coordinate system with many benefits, but also some disadvantages for the Flight Simulator world.) Use of any other projection (Mercator, UTM, etc.) will result in mis-aligned scenery in FS. SBuilderX will automatically re-project Yahoo Maps and Web server aerial images from Mercator projections to the Geographic projection.

Map calibration

As soon as you insert a map in SBuilder (File - Add Map from Disk) you are prompted to calibrate it. You can do it at once by introducing the latitudes and longitudes of the 4 borders of the map, as well as the dimensions of the degrees in the x and y directions.

GIS files with their associated world files, as well as GeoTIFF files will generally either be easier to calibrate or already contain calibration information. Any Map obtained through the SBuilderX image server function will be calibrated automatically.

The various buttons on this window are described below:

- GeoTiff - it makes a copy of the map in Geotiff format.

- Data File - if the Map did not contain calibration information, you can create a simple text file containing this once you have calibrated the Map within SBuilderX, so as to avoid having to calibrate that image in any other projects. The text file will have the same name as the image file and will be found in the Tools\Work folder along with the Map.

A Data File is a simple text file that has the same name as the image file and contains the following information:

[GEOGRAPHIC]
Name=Photo01
North=48.8629079198648
South=48.8430283529953
West=2.30712890625
East=2.32086181640626

The first line indicates the projection.
The second line is the name of the Map in the Map Properties window.
The last four lines are the coordinates of the top-left and bottom-right corners of the image.

- Calibrate - If you do not have CellXDimension degrees and CellYDimension degrees, click here to calibrate the Map. A point calibration window will appear:

You can use this window to indicate the coordinates for different points and SBuilderX will attempt to calibrate the Map based on that information. Click on Calibrate once you have entered the required information.

You can also get a Map using the SBuilder Get Maps web site that appears in the Help Menu. For more information on its use, please see the following topic on the SBuilder support forum:

http://www.ptsim.com/forum/viewtopic.php?f=22&t=1678&start= 0#p5974


Selecting

You select All items of a type in the Select menu. You can also select items in Pointer Mode with a "Selection Window".

To do this you press the Left Mouse, drag while pressing and release when finished selecting. All items that lie on the "selection window" get selected.

Polygons and Maps are selected by pressing the borders and not the interior. This is very important because, for example, you could wrongly try to select a Polygon by clicking on its interior.

Sometimes you may want to use a "selecting window" to be applied to a certain type of item only. Note that the "selecting window" in Pointer mode selects all the types of items (lines, polys, objects, maps, etc). You can select only Lines or Polygons or Objects in Line or Poly or Object mode. In these modes, you need to press and hold the CTRL key when you start the window selection. If you do not press the CTRL key you will start a new item (line, poly or object).

Remember: polygons and maps are selected by pressing the borders and not the interior!


Selecting and Generating BGLs

One basic and central idea in Scenery Builder is that Lines, Polygons, Photo Tiles, Objects, etc have a Selected and a Not Selected (normal) state at any given instant. Actions, such us Deleting or BGL generation, only take place on Selected objects. You can, in this way, generate BGLs in a programmed manner. For example, you can select some of your polygons to generate BGLs only for those selected polygons.

Always remember to first select any or all of the types of elements that you wish to compile into BGLs. If you do not select anything, then the compilation window will tell you:

To select objects, you can either click on them, or drag a selection rectangle around them with the mouse, or use the Select menu:

In this instance, all objects are selected. To compile, you should then click on the BGL Compile tool (the green arrow on the Tool bar). This will display the BGL Compilation window:

If you want SBuilderX to copy the bgl file(s) to your FS scenery folder, you must indicate the path in the Project Properties Window.


Object Library Manager

SBuilderX uses a BGL decompiler by Jon Masterson to implement an Object Library Manager allowing you to easily import new objects from libraries and manage existing object libraries. Select it from the menu Edit-Object Lib Manager... :

To add an object library to the object categories, use the Get Temporary Objects from BGL file field. The Object Library Manager will import all the objects in the library bgl. You can create a new category name for these objects, select any of them (or use Shift+click to select all) and transfer them to the Existing Categories side using the arrow. You can also sort the list of objects in alphabetical order.

All objects imported will then be available for placement with the Object tool.

When SBuilderX is installed, some Objects Categories are automatically created. If you get a BGL library from the Internet containing scenery objects (and thumbnails if possible) you can add this BGL library to SBuilderX using the Manager. As an example, you could add the FSX Vegetation objects.

You start by creating a New Category and giving it a name of your choice. The Category will contain no objects at this stage. Then, you press the button on the side of the Get Temporary Objects from BGL file field and you point to the FSX default file, FSX_vegetation.bgl. When you close the Open File Dialog window, you will end up with over 1600 objects. You can select them all and transfer them to the recently created empty category by pressing the "left" arrow. You can exit the Object Library Manager and use all of the default FSX trees that will appear in the Objects Tool Window right away. However, you will not have any thumbnails. Fortunately, Mischa (an SBuilderX user) created a set of thumbnails for these objects that can be used with SBuilderX. In order to do that, you should exit SBuilderX and download the ZIP file available at:

http://www.ptsim.com/sbuilderx/FSX_vegetation.zip
and place all the JPEGs in the SBuilder X\LibObjects\NewJpegs folder. To complete the installation, you just need to restart SBuilderX. It will take some time for SBuilderX to place the JPEGs in the proper folder, but when it finishes, you will have a thumbnail for most of the default FSX trees.

Mischa also took screenshots for autogen objects, bridges, and buildings. The sets can be downloaded using these links

http://www.ptsim.com/sbuilderx/FSX_autogen.zip
http://www.ptsim.com/sbuilderx/FSX_bridges.zip
http://www.ptsim.com/sbuilderx/FSX_buildings.zip


Tile Server

SBuilderX can use a background image created from tiles downloaded from the Internet. This background image can then assist the scenery designer in creating roads, rivers, lakes, cities, etc, and in placing scenery objects. In this way, scenery items created by SBuilderX will be precisely positioned in the Flight Simulator world. The background image can also be used to make photo-real ground textures.

To obtain the tiles, SBuilderX uses third-party tile server plug-ins that access the most popular image server sites on the Internet. From time to time, new plug-ins or revisions of existing plug-ins are made available by SBuilderX users. If you make a new plug-in and want to share it with other users, please post it here:

http://www.ptsim.com/forum/viewtopic.php?f=22&t=1053

To use the tile server, go to the Edit - Preferences... menu:

Select the desired tile server from the list and make sure to check the "Use xxxServer" box, then click OK.

Then, select the View - Show Background menu and SBuilderX will immediately begin downloading tiles from the selected server at the coordinates and zoom level of the SBuilderX workspace.

Please remember that all images are licensed copyrighted material and may not be used without the permission of their respective owners.

Some web sites restrict the amount of images that can be obtained, so you may find access blocked after a while; simply try again later.


QMID

The Quad Mesh Identifier grid delineates the Flight Simulator world. It is a set of grids that are progressively smaller in size as the quad level increases.

QMID level | Block size (degrees) | One Pixel (degrees) | Meters/pixel
2 | 90 | 0.35 | 38913.62
3 | 45 | 0.18 | 19456.81
4 | 22.5 | 0.09 | 9728.4
5 | 11.25 | 0.04 | 4864.2
6 | 5.63 | 0.02 | 2432.1
7 | 2.81 | 0.01 | 1216.05
8 | 1.41 | 0.01 | 608.03
9 | 0.7 | 0 | 304.01
10 | 0.35 | 0 | 152.01
11 | 0.18 | 0 | 76
12 | 0.09 | 0 | 38
13 | 0.04 | 0 | 19
14 | 0.02 | 8.55E-05 | 9.5
15 | 0.01 | 4.27E-05 | 4.75
16 | 0.01 | 2.14E-05 | 2.38
17 | 0 | 1.07E-05 | 1.19
18 | 0 | 5.34E-06 | 0.59
19 | 0 | 2.67E-06 | 0.3
20 | 0 | 1.34E-06 | 0.15
21 | 0 | 6.68E-07 | 0.07
22 | 8.58E-05 | 3.34E-07 | 0.04
23 | 4.29E-05 | 1.67E-07 | 0.02
24 | 2.15E-05 | 8.35E-08 | 0.01
25 | 1.07E-05 | 4.17E-08 |
26 | 5.36E-06 | 2.09E-08 |
27 | 2.68E-06 | 1.04E-08 |
28 | 1.34E-06 | 5.22E-09 |
29 | 6.71E-07 | 2.61E-09 |

This grid is important because many scenery elements are broken up into separate files. For example,
- quad level 7 - the default airport (APX), bridge (BRX), vector terrain (CVX), and object (OBX) files are in separate quad level 7 files
- quad level 13 - all third-party terrain scenery is created in quad level 13 files by the Flight Simulator tools, except for
- quad level 15 - all third-party freeway traffic scenery is created in quad level 15 files by the FS tools.

You can display the QMID grid in SBuilderX through the View - QMID grid menu. Here is the QMID level 7 grid:


Measure Tool

Slicing (and Filling) to Qmid

In order to get access to the Slice and Fill functions you need to set QMID Grid Display at the level that you want to slice/fill. If the Grid Display is ON, then the context sensitive menu (right mouse) for Lines or Polys will show the commands to execute these functions. Here are pictures showing a 41-point polygon before and after being sliced to Qmid11.

In the following picture many points have been introduced in the polygon. In fact the polygon was divide in more than a dozen of polygons . One of these was separated from the others (the selected polygon with green vertices).

There are situations when it is convenient to slice a polygon (or a line) along the Qmid grid. In the case of polygons you may also need to exactly fill the quads entered by a polygon. One of these situations is explained in this post:

http://www.ptsim.com/forum/viewtopic.php?f=22&t=1629

and a video that shows the slicing of a polygon to solve the problem described in the post can be seen here:

http://www.ptsim.com/sbuilderx/videos/normans.swf


Measure Tool

The measure tool provides an easy way to measure distances and angles on your Map or background image. To invoke the Measure Tool, you can use the Edit-Measure Tool menu item, or simply press the "M" key.

To use the Measure Tool, click once at the beginning location of your measurement, then drag the mouse to the end and click again to end the measurement:

The measurement will display in the top left corner.

You can exit the Measure Tool by either right-clicking, or pressing the "M'" key, or by toggling the Edit-Measure Tool menu item.


Special Keys

Del - to delete selected items. A confirmation dialogue is invoked depending on the setting of the parameter "Ask Delete" in the INI file.

Esc - to end the creation of a Line or Polygon (as the right mouse) or to exit special modes as Automatic Inserting or Taking Screenshots.

Ins - if you press (and release) the INS key while you are in Line (or Poly) mode you will enter a special insert mode. In this mode, you will insert a new point whenever you click in a segment of a line. If you want to exit from this mode you will need to press the mouse right button or the ESC key. This special inserting mode is very important to speed up some tasks.

Ctrl - you can select several Lines or Polygons or Objects with a window in Line or Poly or Object mode. In these modes you need to press and hold the CTRL key when you start the window selection.

Shift - if you press Shift while you make a selection, the new selected items will add to the existing selected items. Otherwise the previous selection is lost.

Space - this can be used in Line mode to create points in a very fast way. You can use it with or without a digitizing tablet. You start the creation of a line and, moving the mouse, you press Space. The result is as if you pressed the left mouse button.

I - to insert a Point on a Line or Polygon.

D - to delete a Point on a Line or Polygon.

B - to break a Line in 2 Lines.

P - if you press and hold this Key, the left mouse button will pan the display (useful for a digitizing pen or for a mouse without a wheel).

Z -if you press and hold this Key, the left mouse button will zoom in (if you move the mouse upwards) or zoom out (f you move the mouse downwards) the display (useful for a digitizing pen or for a mouse without a wheel).

R - if you press and release this key, the left and right buttons of the mouse will be reversed. You exit this mode with the Escape key. This is useful when you have a digitizing pen with a single button.

M - this will invoke the Measure Tool. Also available from the Edit-Measure Tool menu. To close the Measure Tool, press M again or use the menu.

Add - to increase the width of a line. If you press and hold the "+" key and you click on a point of a line, the width of the point will increase by a factor of 1.5

Subtract - to decrease the width of a line. If you press and hold the "-" key and you click on a point of a line, the width of the point will decrease by a factor of 1.5

Up arrow - to scroll through Points when in Manual Checking of Lines or Polygons. If point N is selected and you press the Up arrow, point N+1 will be selected and the display will be centered on point N+1.

Down arrow - to scroll through Points when in Manual Checking of Lines or Polygons. If point N is selected and you press the Down arrow, point N-1 will be selected and the display will be centered on point N-1.

Left arrow - to scroll through Lines and Polygons in Manual Checking of Lines or Polygons. If you are checking Line N or Poly N, pressing this arrow will select point 1 of Line N+1 or Poly N+1.

Right arrow - to scroll through Lines and Polygons in Manual Checking of Lines or Polygons. If you are checking Line N or Poly N, pressing this arrow will select point 1 of Line N-1 or Poly N-1.


SBuilderX is a scenery creation tool for FSX

Making Scenery with SBuilderX


Create a New Project

The first thing you will do is to create a new project. You can either click on the New Project icon in the Tool bar or use the menu item. This will display the Project Properties window.

Besides some important information concerning the number of elements in the project, you should give your project a name in the appropriate field. This name will be given to all the compiled bgl files created by SBuilderX, except for photo scenery and land and water class files. SBuilderX will also append an extension to the name that indicates the type of scenery elements within the bgl.

You can also indicate a scenery folder (for example, the Add-on scenery folder) where you wish to place the compiled bgl files - SBuilderX will automatically place a copy in that folder when compiling.

Once you have done this, you should probably save your project with the name, and in the folder, of your choice. SBuilderX will create a project file (with an .sbp extension) and a backup file as well.


Using the Image Server

SBuilderX contains a built-in image server that will download tiles from all the popular web sites, such as Virtual Earth, Yahoo, Google, and others, using third-party dlls for access to these sites. It is easy to use the image server.

First, select the Edit-Preferences menu:

Choose the desired server from the list, and make sure to check the Use xxxserver below the list.

Then, select View-Show Background from the menu and SBuilderX will immediately begin downloading images from that server for the coordinates and at the zoom level in the status bar, if you have an active Internet connection.

Please remember that all images are licensed copyrighted material and may not be used without the permission of their respective owners.

Some sites, such as Google, restrict the amount of images that can be downloaded - if this happens to you, then you could try resuming the download some other time.


Lines

If you select the Line tool in the Tool bar, you can draw different types of Lines.

To draw a Line, click the mouse anywhere in SBuilderX. With each click, you will draw a segment of the Line. To stop drawing the Line, right-click. To assign the Properties for that Line, right-click on any segment for the context menu and display the Properties Window.

On the General tab, you can give your Line a name, change its color, and modify the width. Also, you can select the type of Line.

Vector Line

Vector Lines can be roads, railroads, shorelines (beaches), freeway traffic, or utility pylons. The Line that you draw will either display an appropriate texture in Flight Simulator, or the relevant objects. You can select the type of Vector Line on this tab:

Textured Lines

You can add markings to aprons by drawing a Textured Line. When you draw the Line, make sure to indicate its desired width. Then, choose the texture:

You can also determine if you want the line to lie flat or if you want it to stand (useful for making fences or barriers.) Lying textured lines should be placed in conjunction with flatten polygons. The height of a standing textured line is the width of the line in the SBuilderX display. The altitude of the line can be used to make "fences" on non-flatten ground. If you include a night texture, then check the appropriate box.

Extrusion Bridges

Extrusion bridges are the new FS X method for inserting bridge objects. Each point on the line will display a bridge pylon, and will have a height above a plane determined by the 2 end points. Go to the tab to select the bridge model:

By clicking on the Properties button, you can indicate more parameters:

The width of the bridge should correspond to the width of the road as determined in the terrain.cfg file. Unless you will have freeway traffic passing over the bridge, it is best to Suppress the Platform, as they have a large impact on performance. You can set the height of the bridge in 3 different ways:

1. Set the maximum height in the above window. SBuilderX will calculate a gradual rise from one end of the bridge to that height, and then descend to the other end.
2. Set the height in the General tab. All points will have the same height.
3. You can set the height of each point individually by right-clicking on each and displaying its Point Properties window.

Lines of Objects

You can draw a line that will display the same object at each of its points. The object can be any that is part of an Object Category. You can set the orientation (Heading) of all the objects or have this determined randomly.


Polygons

You can make different polygons with SBuilderX:

1. Vector Polygons, including:
- exclusion polygons that only exclude terrain items, not objects
- airport backgrounds, that is, flattens, autogen exclusions, and airport skirtings (grass masks)
- hydro polygons, water bodies such as oceans, lakes, rivers
- land class polygons that display a land class of your choice with associated autogen

2. Textured Polygons with a texture of your choice

To use the Polygon Tool, select it in the Tool bar, then click on the SBuilderX workspace to draw it. When you have finished, right-click to end drawing.

To assign a Property to the Polygon, right-click on the edge of the Polygon and select Properties from the menu:

In the General tab, you can give the Polygon a name, set its altitude if needed, change the drawing order of a Textured Polygon, and select the type of Polygon.

Vector Polygons

By selecting Vector Polygons, you will display the appropriate tab:

Here you can select the specific kind of Vector Polygon and change the display color in the SBuilderX workspace.

Textured Polygons

If you prefer to use a custom texture for your Polygon, select the Textured Polygon type:

Select the texture, tiling, visibility and other options. Once you have selected the texture, it will display in the preview window with a representation of the Polygon on top. You can move the Points of the Polygon so as to only display a part of the texture.


Objects

SBuilderX will place a large variety of objects. To place an object, select the Object Tool from the Tool bar, and click on the SBuilderX workspace on the location desired. The Object Properties Window will display where you can select the type of Object.

Library Objects

The Library Objects tab will display the list of all Objects that are included in the Objects.txt file:

You can add more libraries using the Object Library Manager or by manually editing the Objects.txt file. You can add both FS 9 object libraries and FS X object libraries.

MDL Placement

If your object is not in an object library, you can still place it using SBuilderX. Select the MDL file to place in the appropriate tab:

The MDL file can be compiled with either the FS 9 or FS X game packs. SBuilderX will create an object library bgl with the MDL file. You must remember to place the required textures in the texture folder of your local scenery.

Generic Buildings

The Generic Buildings tab will let you create a new building or use a stored building from the list:

The list included in SBuilderX contains a representative sample of just about all the building types available of which many buildings were taken from the default Flight Simulator files. In addition, for some buildings that could not be found in the default files, the list of stored buildings has samples, particularly of the FS9/FSX hangar and terminal types - you will recognize these because their names begin with the texture used, e.g. T126-Hangar,Large-50x35.

To use a stored building, select it from the list and press the Load button. You can then either place it directly or modify it by clicking on the Detail button.

Or, you can create your own building by setting the width and depth, then clicking on the Detail button:

You will find a list of texture numbers in an appendix. Here are some tips for creating buildings:

1. According to the World Coordinate System used in Flight Simulator, Width is the x coordinate and Depth is the z coordinate. Height is the y coordinate. It is easy to become confused.

2. The appendix indicates the texture numbers for different types of buildings and what seem the corresponding window, gable, and face textures that best fit the bottom and top textures. However, you are free to mix and match textures as you wish.

3. The buildings from before FS 9 will display mostly correctly in the preview window, but FS9/FSX hangar and terminal buildings follow a set of complex display rules and have a certain randomness built in, so the preview will not be exactly what you will see in FS.

4. The ACES artists created the textures so as to display best in FS when the height is set to 5 meters or a multiple of that number. Again, you are free to choose a different height.

5. The FS9/FSX terminals (textures 86-121) and hangars (textures 122-151) have double textures. That is to say that 86 and 87 are the same texture, but displayed differently, as are 88-89, 90-91, etc. Because of the complex rules concerning the display of these textures, it is impossible to preview them correctly, but SBuilderX will reverse the pair to alert you to the difference between them.

6. Some of the FS9/FSX hangar and terminal buildings will display the window texture (usually some sort of siding) on the depth side (z axis). Others, however, will use the same texture as the front with a door. To avoid having a door on the side of these buildings, use Z Tiling of 0.50 or less.

7. Multi-sided buildings have a Smoothing option - it is included in SBuilderX because of the requirements of compiler code, but it does nothing.

8. Like all objects, generic buildings should be placed on flat surfaces or they risk having parts of the building hanging in the air.

Macros

You can place old-style macros from your collection and SBuilderX will generate the bgl files using Manfred Molderhauer's SCASM. This means that the bgl files can also be used in versions of FS prior to FS X. In order for the macro to appear in the Object list:

you should go to the Edit-Preferences window and indicate the path to the correct folder.

Rwy12 Objects

You can also place all Rwy12 object libraries if you have them. Indicate the proper path to the Rwy12 folder in the Edit-Preferences window or they will not appear in the tab:

Other Objects

SBuilderX can also place different types of object:

  • FS 9 and FS X MDL files
  • Taxiway Signs
  • Beacons
  • Windsocks
  • Effects

Using the Measure Tool in Object Mode

If you are in Object Mode, then you can use the Measure Tool to determine the dimensions and orientation (Heading) of the object that you will place. And you can have the Heading automatically inserted in the Object Heading field.

First, make sure that you have selected the Object tool from the Tool bar. Then, toggle the Measure Tool on, either by pressing the "M" key or using the Edit-Measure Tool menu entry. Then, measure the location on the background where you wish to place the Object:

When you have finished measuring, exit the Measure Tool with a right-click. Then, place the object with a left click of the mouse. The General tab on the Object Properties window will automatically contain the Heading of your measurement:


Land Classification

Land Class is the method that Flight Simulator uses to determine the type of ground texture that is displayed. There is a default land class file that covers the entire FS world. You cannot exclude land class values, but you can create a new land class file that covers the area of your scenery - this file will display instead of the default files in that area.

To start creating land class files, click on the Land Class tool on the Tool bar. This will display the Land Class Properties window:

This window can be dragged off the SBuilderX workspace and kept open until you have finished creating land class. SBuilderX will also display a QMID level 15 grid to aid in determining the limits of each land class value.

You can choose the land class type that you want in the list and decide whether you wish to place by clicking or by dragging (Raster) the mouse. Or you can choose to delete land class values. You can also choose the size of the insertion.

Please note that the FS world has 26 different regions and that ground textures for the same land class value can display differently in different regions. When you install SBuilderX, it makes copies of the North America region ground textures for display in the above Properties window. So, the image of the ground texture is not necessarily what you will see in FS if your scenery is outside of that region.

When the land class file is compiled by SBuilderX, it will not have the Project name that you define in the Project Properties window, but instead a composite name formed by adding LC and the u,v coordinates of that Cell for your project.

Append RAW

You may have RAW image files created by other Land or Water Class creation tools. You can import them into SBuilderX using the Append-RAW menu item, but you must ensure that they have a specific name:
- for Land Class, the name must have a "LC_" prefix followed by the Cell identifier, for example, "LC_3025.raw
- Water Class files must have a name with a "WC_" prefix followed by the Cell identifier, for example, "WC_3025.raw"

Class Maps

A special feature of Scenery Builder is the capability of generating a BGL from a bitmap representing the use of land or the type of water. Such a bitmap is called a Class Map. These bitmaps have a number of different colours equal to the number of used classes. You should use the File-Add Map-From Disk... menu to place this bitmap in the workspace. Then, in the Properties window for that Map, make sure that the name begins with "Class".

Scenery Builder translates each colour of the "Class Map" in from 1 up to 3 generic textures or classes. The 3 classes are defined in a probabilistic way in order to avoid continuously repeating textures for a region with the same class index.

In order to use this facility, you start to assign "colours to classes" by pressing "Edit" in the Class Map section of the Land or Water Class Properties window.

This will open the Project Properties window on the Class Scenery tab.

You will add the Class Definitions (the Land or Water Class values for each colour). Add 3 Land or Water Class values preceded by either "Land" or "Water" and followed by an optional descriptive text. You can determine the colour for each Class Definition by clicking on the coloured label and either choosing from a palette or directly from the Class Map (the bitmap). Once you have confirmed the Class Definitions, press "Make" in the Land or Water Class Properties window to generate the "Land or Water Class" tiles.

Further Reading

The following is an excerpt of a topic that I wrote in the MSFS Scenery Design Forum at http://www.avsim.com.

The TMF Resampler programme, made available by Microsoft (and used by SBuilder), can create:

  • mesh scenery ( TYPE = ElevS16LSB )
  • land class scenery ( TYPE = ClassU8 )

In both cases a BGL file is generated covering a region that we specify in the destination section of the INF control file. This region can not be smaller than a certain size. This minimum size corresponds to 257 x 257 elevation points or 257 x 257 class indexes. The elevation points and the class indexes are the vertexes of LOD squares. In the Land class case the class indexes are the vertexes of LOD 13 squares (or Areas). Therefore the smallest region that we can have in Land class scenery is a LOD 5 region. In the case of the elevations points it depends on the LOD. For example for a "LOD 10 resolution" mesh, the elevation points are vertexes of LOD 18 squares. In this LOD table:

 | Sample Size Meters |  | Degree Boundaries |  | Span Meters
LOD | N/S | W/E | Latitude | Longitude | N/S | W/E
0 |  | 52087,50 | 90 | 120 | 10000800 | 13334400
1 | 19532,81 | 26043,75 | 45 | 60 | 5000400 | 6667200
2 | 9766,41 | 13021,88 | 22,5 | 30 | 2500200 | 3333600
3 | 4883,20 | 6510,94 | 11,25 | 15 | 1250100 | 1666800
4 | 2441,60 | 3255,47 | 5,625 | 7,5 | 625050 | 833400
5 | 1220,80 | 1627,73 | 2,8125 | 3,75 | 312525 | 416700
6 | 610,40 | 813,87 | 1,40625 | 1,875 | 156263 | 208350
7 | 305,20 | 406,93 | 0,703125 | 0,9375 | 78131 | 104175
8 | 152,60 | 203,47 | 0,3515625 | 0,46875 | 39066 | 52088
9 | 76,30 | 101,73 | 0,17578125 | 0,234375 | 19533 | 26044
10 | 38,15 | 50,87 | 0,08789063 | 0,1171875 | 9766 | 13022
11 | 19,08 | 25,43 | 0,04394531 | 0,05859375 | 4883 | 6511
12 | 9,54 | 12,72 | 0,02197266 | 0,029296875 | 2442 | 3255
13 | 4,77 | 6,36 | 0,01098633 | 0,014648438 | 1221 | 1628
14 | 2,38 | 3,18 | 0,00549316 | 0,007324219 | 610 | 814
15 | 1,19 | 1,59 | 0,00274658 | 0,003662109 | 305 | 407

there is no LOD 18 entry. But it easy to see that for a LOD 18 the Span in Meters would be 38,15 in the N/S direction and 50,87 in the W/E direction. We conclude that the minimum mesh region that we can generate at LOD = 10 is, precisely, a LOD 10 square (9,8 Km by 13 km) with elevation points at the vertexes of LOD 18 squares (38,2 m by 50,9 m). For a mesh (at LOD = 10 resolution) covering (spanning) 2 x 2 LOD 10 squares, we need 513 x 513 points. We can realize this mesh with 4 BGLs each covering a LOD 10 square and having 257 x 257 elevation points. Or we can realize it with a single BGL with 513 x 513 elevation points covering the same 4 LOD 10 squares. The 2 situations will produce the same result if Point 257 on the left (upper) square is identical to Point 1 on the right (lower) square. This will be more clear with the discussion at the end of this post for land class scenery.

We saw that a land class BGL spans a whole LOD 5 square (312 km by 418 km - so not really a square!). If we want to work a smaller area we use index = 254 (which is transparent) in the regions that we do not want to change (note: SBuilder will place this 254 index for you). Consider this example:

The big white squares are LOD 13 Areas. These Areas have small squares at the vertexes. In the figure we see 20 vertexes. For each of the vertexes we define a land class index. We have 12 white (say white means index = 254 or transparent) vertexes and 8 coloured vertexes. Since a vertex affects 4 squares we could expect a final result like this:

But the final result that FS shows is much better. Firstly a square is displayed only if all their 4 corners have significant land class indexes (different from 254). Secondly FS mixes the 4 textures that corresponds to the 4 land classes and blends them in a manner similar to what is shown in the following figure:

The rest of the post is in the AVSIM archives.


Water Classification

Water class is the method used by FS to display different types of water color. Unlike land class, there are no regional differences in water class.

To create a water class file, select the Water Class tool. This will display the Water Class Properties window:

Just like the land class, you can select the desired water class type, and the means of inserting the value on your project. You can also make a Class Map for water class, just like land class.

When the water class file is compiled by SBuilderX, it will not have the Project name that you define in the Project Properties window, but instead a composite name formed by adding WC and the u,v coordinates of that Cell for your project.


Custom Ground Textures

To make custom (photo-real) ground textures, you can use the following as sources:

  • any aerial or satellite image for which you have georeferencing information (coordinates and pixel widths)
  • any GeoTIFF image (that already contains georeferencing information within the image file)
  • the SBuilderX image server tiles

Using a Map to create custom ground

If you do not use the image server tiles, the you must first add the Map to the workspace using the File-Add Map menu. Then, if required, you must calibrate the image.

First, make sure that the Map Name begins with Photo or SBuilderX will not be able to recognize this Map as a source for custom ground textures. You can also give the Map a descriptive name because this is the name that will be used for the compiled bgl file.

If you do not know the Cell Dimension values, you can try letting SBuilderX calibrate. Press the Calibrate button to get the Map Calibration window:

You can indicate the coordinates of the top left and bottom right pixels and SBuilderX will calibrate the Map. Or you can choose any 2 points on the Map, although for best results they should probably not be too close to each other.

Once you have calibrated the Map, you can select it, either by clicking on its edge or using the Select menu. Then, click on the Compile BGL button on the Tool bar to create the bgl.

Using the image server to create custom ground

If you use the image server function, then you should ensure that you have gotten all the tiles from the Internet that you will need to cover the area of your custom ground. You should also get tiles for different zoom levels so that you can display all the desired area in the smaller Add Map from Background window.

To use the background tiles as a source for custom ground, you can use either of 2 methods:

First Method
1. First, view the area of your choice at the desired zoom level. Right-click on the background to bring up the context menu:

Select Background... in order to immediately compile the SBuilderX workspace into custom ground:

The SBuilderX workspace is 1792 x 1280 pixels in size and that will be the extent of the custom ground, although the resolution will depend on the zoom level of the background. SBuilderX will also apply a simple blend mask that will blend the custom ground into the default textures along a thin band on the edge of the image.

The compiled bgl will be placed in the SBuilder X\Tools\Work folder. Once your custom ground file has been created, you can change the name of the bgl to something more descriptive.

Second Method
2. You can select the precise area for which you want custom ground, SBuilderX will make it into a "Map" (with its own calibration text file), and that "Map" can be selected and compiled into a bgl. The Map can also be edited to correct colors, add transparent areas, or as a basis for creating blend masks and water masks.

First, you should zoom out so that the entire area of your choice is visible in the SBuilderX workspace. Then, go to the menu File-Add Map-From Background:

Draw a selection rectangle around the desired area with the mouse, and choose the maximum zoom level of your scenery. You can see the projected size of the Map in the top part of the window. Your computer will probably need much more memory than this in order to create the bitmaps from the downloaded tiles. If you do not have sufficient memory for this function, then an error will display and the Map will not be created. You can try making smaller selections if that happens.

Please note that if you have not gotten all the tiles for that zoom level, your custom ground may have blank areas in white. To prevent this, SBuilderX will attempt to download any missing tiles if you have an active Internet connection before making a Map.

If you right-click on the edge of the Map, you can bring up its Properties window. Note that SBuilderX will give the Map a name that begins with "Photo". This is the name that will be given to the final bgl. You can change the name of the Map to anything that you wish, but it must start with "Photo" so that SBuilderX can recognize it as a source for custom ground. And, once the bgl has been created, you can change its name to anything that you wish.

If you decide to use the Map to create seasonal or night variants of the image, you can indicate them in the second tab of the Map Properties window.

To create the custom ground bgl, simply select the Map (either by clicking on its edge, or by using the Select menu) and click on the BGL Compile icon (the green arrow) on the tool bar, which will bring up the Compilation window. The compiled bgl will be created in the scenery folder you indicated when creating the project and, in all cases, in the SBuilder X\Tools\Work folder.

Blend and Water Masks

To add blend masks or water masks to your custom ground, you can create them using the original image as a basis, and then save them with the same name, but using a suffix to indicate this. The files should be saved as TIF images, for example:

original image - L17X132735X132743Y90177Y90183.BMP

blend mask - L17X132735X132743Y90177Y90183_B.TIF
water mask - L17X132735X132743Y90177Y90183_W.TIF

Make sure that those files are in the SBuilderX\Tools\Work folder along with the original image, and SBuilderX will automatically integrate the blend and/or water mask in the custom ground.

Compression Quality

FS X allows for varying the compression of the final bgl. It has been determined that reducing the Compression Quality parameter from 100 to 85 or 75 will greatly reduce the size of the final bgl (up to a quarter of the original size). You can change the Compression Quality in the SBuilder.ini configuration file.

Seasonal Variants

You can indicate when the seasonal textures should display by modifying the entries in the SBuilder.ini file:

HardWinterVariations=January
WinterVariations=December,February,March
FallVariations=October,November
SpringVariations=April,May,June
SummerVariations=July,August,September

Change these entries to have seasonal variants appear on different months. Please note that FS X seasons begin on the first day of each month, unlike FS 9.


Exclusion Rectangles

You can draw exclusion rectangles to remove scenery objects. Please note that you should not use these exclusions to remove autogen. To remove autogen, use a Vector Polygon instead with one of the Airport Background properties. Exclusion Rectangles only remove objects that have been placed using BGLComp. Select the Exclude Tool from the Toolbar and then drag a rectangle over the location of the objects that you wish to exclude:

Make a selection from the list - you can exclude all or any combination of objects.


Tutorials

In addition to this Help file, you can consult numerous tutorials covering different aspects of scenery design and creation using SBuilderX by visiting the Tutorials page at www.ptsim.com. Among others, you will find:

Terrain Design for Flight Simulator X

This document covers all aspects of vector terrain creation. It was written for an early version of SBuilderX, so the interface will be different, and you will no longer need the Manifold toolbar to get image tiles, since SBuilderX now has its own tile server.

Make photo-real ground textures in Flight Simulator X

In this text, you will learn how to make custom ground textures from aerial images.

Illustrated Guide to Extrusion Bridges

This is a complete explanation of the techniques for creating extrusion bridges, written before the function was included in SBuilderX

Video Guide to Macros

This shows the placing of some FS9 macros. It is old but illustrates some aspects of the SBuilderX user interface.


SBuilderX is a scenery creation tool for FSX

SBuilderX Reference


File Menu

The file menu contains the commands to open and save SBuilder projects, and many others such as entering data from GIS (Geographic Information Systems) files or generating BGL files for Flight Simulator.

New Project -Deletes all the data in the present project and opens a dialogue to setup the properties of a new project. You can use this command through the Toolbar..

Open Project - Opens an existing project file. Project files are created by SBuilder and have a default extension of SBP (meaning Scenery Builder Project). You can use this command through the Toolbar.
Note: SBP is a binary file format that can only be read by SBuilder. Save Project - Save the project as an SBP (SBuilder Project) file.

Save Project - Save the project with another name.

BGL Compile - Display the Compilation window where you can generate bgl files.

Properties - Display the Project Properties window.

Every project has a name. The default name is PROJECT. The type and the number of all the items contained in the project are shown here. If you get lost in the display you can always check the numbers of lines or polygons or other items. If you do not see them in the display you need to change the display settings or look for the items in other locations
The second tab contains Properties concerning the generation of Class scenery.

SBuilder can generate Land (and Water) Class scenery from a calibrated bitmap. That bitmap is called the Class map and it is a bitmap with a limited number of colours. Each colour in the Class bitmap represents a land (or water) class index or a Class definition. The Class definition is a set of 3 class indexes that refer to a colour. When making Land (or Water) Class scenery in this way, SBuilder uses 1 of these 3 numbers every time it finds a tile with this colour. SBuilder chooses the index to use in a randomly way. 60% of the times it uses the first index, 25% the second and 15% the third index. When you click on Add, you will get this window:

When you have created several Class definitions they appear on the left bottom box of the Class Scenery tab. You click on a particular line of this box to select a particular Class definition which then appears in the upper box. By double clicking that upper box you can change the colour that corresponds to the definition.

Import SBuilderX SBX ... - You can import projects as SBX files. These are simple text files that can be opened in Notepad. Often, it is easier to see project details and find errors in an SBX file. You can also import SBuilder for FS9 SBX files into SBuilderX, that is, projects made for FS 9 can be imported correctly into SBuilderX and compiled for FS X.

Append - You can append different types of files to your project:

Append-SBuilderX SBX ... - unlike Import SBX above which will replace any existing elements in your project, appending an SBX file will add its elements to those existing in the workspace.

Append-Surfer BLN - You can also append terrain elements contained in BLN files. The BLN format is a very simple XYZ ASCII format used by many GIS programmes. There are also free converters that convert, for example, DXF files to BLN files. You will have to define the Properties of the Lines and/or Polygons that are in the BLN file:

Append-Object BGL/XML - You can import the contents of any object file. If it is compiled in a BGL, then SBuilderX will decompile it. Then, the objects will be placed in the SBuilderX workspace with all their Properties.

Append-ESRI SHP - Shapefiles can be imported with any Properties defined in its accompanying .dbf file:

Append-Class RAW - You may have RAW image files created by other Land or Water Class creation tools. You can import them into SBuilderX, but you must ensure that they have a specific name:
- for Land Class, the name must have a "LC_" prefix followed by the Cell identifier, for example, "LC_3025.raw
- Water Class files must have a name with a "WC_" prefix followed by the Cell identifier, for example, "WC_3025.raw"

Export - You can export your SBuilderX projects in different formats:

Export-SBuilderX SBX ... - The SBX format is exported in a text file and can be read with Notepad.

Advantages of SBX files:
  • in many cases you can debug your project if anything goes wrong by examining the SBX file
  • the selected state of items is saved so that when you import the SBX file the same items are selected as when you exported the project
  • if you want to merge 2 projects - Project1 with Project2 - each in its SBP files, you open Project2 and export as temp.SBX. Then you open Project1 and you append temp.SBX. Note that you can not append SBP projects
Disadvantages of SBX files:
  • the files can be very large
  • you lose land or water class scenery when you export a project with class scenery.

Export-Surfer BLN ... - The BLN file format is a very simple XYZ TXT format for data interchange. Many GIS programmes can export in this format.

Note 1: you lose the BGL properties of lines and polygons when you export to a BLN file; also you are limited to lines and polygons.
Note 2: in version 2.05 of SBuilder we changed the header in order to make the format compatible with other GIS programmes. For example, in version 2.02, the line 5,My_Line was 5,0,My_Line. This caused problems with the header being interpreted as a point in some GIS tools.
Note 3: in this example the character "," is used as a separator. You change this character through the SBuilderX.ini file. If you want the numerical values in the BLN file to be separated, for example, by a tab you need to edit the SBuilderX.ini file so that the following line is:

BLNSeparator=tab

Export-ESRI SHP ... - You can export terrain elements in your project as Shapefiles. SBuilderX will generate all the elements of the shapefile, including the database file (dbf) with the Properties of the elements. Shapefiles will be created for each of the FS X terrain types.

Add Map - SBuilderX can get Maps from different sources:

Add Map-From Disk ... - You can add an image file as a Map. It can be in BMP, TIFF, or GeoTIFF format. The first two types must be calibrated in SBuilderX, but the GeoTIFF files already contain georeferencing data and will be calibrated automatically by SBuilderX.

Add Map-From Background ... - If you have downloaded image tiles using the SBuilderX image server function, then you can select a part of those images to transform into a Map. You can then use that Map to create custom (photo-real) ground textures.

Add Map-Yahoo Map ... - If you have an active Internet connection, you can use this item to get a Map directly from the Yahoo Maps server.

Exit - This will exit SBuilderX. Be sure to save your work first before exiting the program.

Recent Files - At the bottom of the menu is a list of the 4 most recently opened files. Note that the list is updated when you open a file that is not in the list. Appending or importing will not update the list.


Edit Menu

The Edit Menu contains some items such as one would normally expect to find.

However, not all work the same as expected. The Copy and Place commands are limited to certain type of items and do not work as in normal Windows applications. For example, if you have SBuilder running in 2 different windows, you can not copy from one window and paste in the other, as you normally can in other graphical applications.

Undo - You can undo some actions if you have set the correct entry in the Edit-Preferences window.

Redo - Same as above.

Measure Tool - You can toggle the Measure Tool on and off using this menu item. Or, you can activate the Measure Tool by pressing the "M" key.

Object Lib Manager ... - This will display the Object Library Manager where you can add Object Libraries to the groups of active libraries for use in the Object Tool. You can also use the Object Library Manager to edit the various libraries.

Copy - You can use this function in order to create a copy of Lines, Polygons, or Objects, in conjunction with the Paste command.

This command Copies an element from the Display and places it the "SBuilder Cache". In order to Copy a Line, Polygon or Object, you must select it first. When you Copy an item, the Paste command in the Edit menu becomes enabled.

Note 1: you can Copy Lines, Polys and Objects. This function only works in Polygon, Line and Object Modes.

Note 2: you can only Copy one element at a time. It is impossible to Copy more than one element. If you have several elements selected, only the last one that has been selected is Copied.

Note 3: in Pointer Mode you can not Cut, Copy or Paste.

Note 4: the "SBuilder Cache" is not the Windows Clipboard.

Place - In order to make copies of Lines, Polygons, or Objects, you must first be in the appropriate mode. For example, to make copies of an Object:

1. Select the Object Tool from the Tool bar;
2. Click on the Object to select it;
3. Chose the Edit-Copy menu item, or use the keyboard shortcut Ctrl+C;
4. Chose the Edit-Place menu item, or use the keyboard shortcut Ctrl+V to begin pasting.
5. Click on the location where you wish to paste a copy of the object.
6. Continue to click in order to paste more copies of the object.
7. When you have finished pasting, you must exit the Place function either by using the keyboard shortcut or toggling the menu item.

Delete - This command permanently removes an element from SBuilderX. In order to delete an element, you need to select it first. You can invoke this command through the Edit menu or using the Delete key.

If you invoke the function through the Edit menu, only one element is deleted at a time (the last one that has been selected). Also, you can only delete Lines, Polygons or Objects though the Edit menu.

If you press the Delete Key, you can delete every type of element (not only lines, polygons or objects). Every selected items will be deleted after you confirm that you want to delete all selected items.

Note: you can delete any item through the Pop up menu invoked by clicking an element with the right mouse button.

Find - You can use this to search for different elements in your project:

You can search either using the name or the GUID of the element. When you create a Polygon or a Line or an Object, you can give them names. By giving names to your elements, you keep your projects organized. One thing that you can do is to search a Line or Polygon by its name. But you also can select items by type. For example, you have a project and have lines that are streams and other lines that are roads. You want to select all the streams to make, for example, a global change on the streams. In order to select all the streams, you can make a Search on the Stream GUID.

FSX Settings - This will display a window where you can set the paths to important folders:

Normally, SBuilderX will find the correct paths when installed. Please check this window in case of problems.

Preferences - The Preferences window has two tabs, Background and Object Folders:

- Background - You can select the tile server to use for downloading image tiles from the Internet. You can also turn Undo and Redo on or off.

- Object Folders - Here, you should indicate the paths to object folders so that they will be available in the Object Tool.


View Menu

The View menu allows you to adjust the SBuilder display to better suit your work, and you can move or manipulate the display in various ways.

Show Toolbar - You can toggle the Toolbar on or off.

Show Background - This will display any image tiles in the SBuilderX cache or initiate the download of tiles from an image server on the Internet for the zoom level and coordinates in the SBuilderX workspace.

QMID Grid - You can display Quad Mesh Identifier grids if you wish.

Go to Position ... - This will display a window where you can indicate coordinates.

By clicking OK, the SBuilderX display will be centered on those coordinates.

Show Aircraft - If you have Flight Simulator running in a different window, you can see the FS aircraft displayed as a small red cross in the SBuilder window. The command also centers the display at the location of the aircraft. In order to get this facility you need to download FSUIPC.DLL from:

http://www.schiratti.com/dowson.html

Fly Aircraft to ... - With this command, you can position the FS aircraft at a location whose coordinates are the latitude and longitude of the SBuilderX display centre. This is very useful to see the scenery that you are editing or creating in FS.

Note 1: The Show... and Fly To... commands are normally used with FS in Slew mode.

Note 2: If you have FS running on a different window, SBuilder cannot copy BGL files to any installed scenery folder. You need to close FS, generate the BGLs and start FS again.

Maps - Maps consist of sets of different images representing all seasonal and night variants. You can choose which variant to display in the SBuilderX workspace:

All Maps
All Land Tiles
All Water Tiles
All Lines
All Polygons
All Objects
All Excludes
View All

With these commands, you can toggle the display of all the different scenery elements on and off.


Select Menu

Through this menu, you can select and deselect with a single click all the elements in the Project or all the elements of a type in the Project.

This is very useful when you are ready for compilation. If you want to generate several types of scenery elements simultaneously, you need to go to Pointer mode. In Pointer mode, you can select all the types of elements that you want. But, if you have selected a specific tool from the Toolbar, then only the elements of that tool can be selected.


Tool Menu

This menu allows you to select between the various modes of operation (the different tools). Unless the Toolbar View is disabled, you can enter any of the modes by pressing its corresponding button in the Toolbar.

Pointer mode

In this mode, you make operations that affect all the type of items. For example you can select Lines and Polygons simultaneously. You can move points from lines and points from polygons at the same time. You can select all the existing items in a project if you are in Pointer mode. If you are in a specific mode, for example in Line mode, you can only select Lines.

Also in Pointer mode you can use the "window selection tool".

Zoom mode

In Zoom mode, you Zoom in by left-clicking the display and you zoom out by right clicking the display. In addition, the display is centered on the clicked point. If you have a mouse wheel, you will probably seldom use the Zoom mode.


Help Menu

The Help menu contains various items providing more information on the use of SBuilderX:

SBuilderX Help - This will launch the SBuilderX Help file.

SBuilderX Forum - This will take you to the PTSim forum dedicated to SBuilderX Scenery Design.

Get Map from the WEB - PTSim provides a very handy web page where you can get Maps from image servers. When pressing Get Map from the WEB in the Help menu, the web page will open in the location of the SBuilderX display and using the same Zoom.

About - This opens a window with some basic information concerning SBuilderX, including the version number.


SBuilderX is a scenery creation tool for FSX

SBuilderX Appendix


Appendix - Get Background Tiles

GetBackground is a stand-alone program that will download tiles from image servers on the Internet for use with SBuilderX. You do not have to launch SBuilderX in order to use it. Simply make sure that it is in the SBuilderX root directory before starting it.

Indicate the coordinates of the boundaries that you desire, the zoom level, and the image server from the list. The Get Background Tiles application will then start downloading all tiles and place them in the SBuilderX tile cache folder.

Please note that some image servers, particularly Google, block this type of application.


Appendix - Get Background Tiles

Appendix - Tiles Cache Reorganizer

Tiles stored by SBuilderX version 3.10 were placed in a single folder. As the number of tiles increased, the task to check the presence of a Tile in that folder could slow SBuilderX. In order to resolve this problem, Tiles are now stored in structured folders as shown in this picture:

In order to reuse tiles previously recorded with SBuilderX version 3.10, a small tool is included. The tool is called Tiles Cache and, to use it, please follow the instructions in the initial window of the tool.


Appendix - INI File Entries

The SBuilder.ini file is located in the SBuilderX root folder and contains many entries that you can modify:

[Recent Files] - This section contains a list of the most recently opened projects.

[RecentDirs]
ShapeDir=
OpenDir=
ImportDir=
AppendDir=
SurferDir=
TexDir=
SaveDir=
BmpDir=
ObjectDir=
RawDir=
LibDir=

These entries will contain paths to the most recently used folders for each function.

[Main] - The main section contains the following entries:
- DefaultLC=10 - This is the default value for the Land Class Tool.
- DefaultWC=12 - This is the default value for the Water Class Tool.
- LonIniCenter=-69.9 - This is the default value for the longitude of new projects.
- LatIniCenter= 18.5 - This is the default value for the latitude of new projects.
- DecimalDegrees=True - You can toggle decimal degrees on or off. The format is Degrees Minutes Seconds if set to False.
- MeasuringMeters=True - You can toggle the units used for the Measure Tool. You can measure in Feet if set to False.
- ShowAircraftPeriod=5000 - This is the period of time for sampling aircraft position in Flight Simulator, measured in milliseconds.
- BorderON=True - This displays a border around Maps. It is probably best to leave this to True.
- AskDelete=True - This will invoke the Confirmation dialogue when deleting an element.
- BGLFolder=C:\Program Files\Microsoft Games\Microsoft Flight Simulator X\Addon Scenery\scenery - This sets the default path to the folder where you wish your compiled bgls placed.
- SelectedPointColor=FF008000 - This is the colour of selected points in hexadecimal values as AARRGGBB (Alpha, Red, Green, Blue).
- UnselectedPointColor=FFFF0000 - This is the colour of unselected points in hexadecimal values as AARRGGBB (Alpha, Red, Green, Blue).
- AutoLinePolyJoin=False - This will set the automatic joining of Lines and Polygons. Only set it to True when you need to join Polygons or Lines
- ShowLabels=True - This will display the labels (names) of Lines and Polygons.
- DisplayJoin=True - When set to True the joining of Lines and Polygons will happen when the items to join come closer than 3 pixels. The Joining is then a function of display.
- DirJoin=True - If set to True the joining the Direction of Lines is considered in joining, eg, the starting point of a line only joins with the ending point of the other line.
- NameJoin=True - This will set the joining of Lines and Polygons if they share the same name.
- NoEndsSmooth=True - This is the default value for the Smooth function. The smoothing is not performed on the extreme segments of a line or polygon.
- CornerSmooth=True - This is the default value for the Smooth function. Set it to Flase if you want to preserve "corners" when smoothing.
- SampleDistance= 250 - This is the default value for the Sample function.
- SmoothDistance= 5 - This is the default value for the Smooth function. If 2 points are near than the parameter value no point will be introduced between them.
- BackUpON=True - When set to True, SBuilderX will always create a back-up of your project file.
- BackUpSeconds=60 - This determines how often the project is backed-up.
- OriginalTerrainCFG=False - Set to False in order to use the Terrain.CFG file proposed by Luis Feliz-Tirado and Richard Ludowise
- GridColor=FF00FF00 - You can change the color of the grid, for example, to yellow with this value: FFFFFF00.
- CenterOnMouseWheel=False - You can center on the zoom point when using the mouse wheel.
- AircraftAltitudeOffset= .5 - The function to get the Point altitude from aircraft can be rectified by entering a value here.
- ExtraExtrusionAltitude=-20M - SBuilderX creates extra points at each extremity of an Extrusion Bridge Line. You can set their height value here.

[Objects]
Rwy12Path=
MacroAPIPath=
MacroASDPath=
LibObjectsPath=

These are the paths to the relevant folders as set in the Edit-Preferences menu.

[Lines]
- DefaultLineAltitude= 0 - The default altitude for newly created Lines.
- DefaultLineWidth= 5 - The default width for newly created Lines.
- SelectedLineColor=FF008000 - The color of selected lines in hexadecimal value as AARRGGBB (Alpha, Red, Green, Blue).
- DefaultLineColor=FF0000FF - - The color of unselected lines in hexadecimal value as AARRGGBB (Alpha, Red, Green, Blue).
- MakeClosedLineFromPoly=False - When using the Make Line function from a Polygon, you can choose to close the line, for example when making a lake shoreline.

[Polys]
- DefaultPolyAltitude= 0 - The default altitude for newly created Polygons.
- PolyFILL=True - Determines whether Polygons are filled with colour.
- DefaultPolyColor=80FFFF00 - The default colour for newly created Polygons.
- PolyColorBorder=FF000000 - The default colour for the border of newly created Polygons.

[Shapes]
- ShapeLineGuid={89ABCDEF-EDCB-A987-6543-210FEDCBA000} - The default GUID for appended Lines in shapefiles.
- ShapeLineAltitude= 0 - The default altitude for appended Lines in shapefiles.
- ShapeLineWidth= 50 - The default width for appended Lines in shapefiles.
- ShapeLineColor=FF0000FF - The default colour for appended Lines in shapefiles.
- ShapePolyGuid={9ABCDEF0-FEDC-BA98-7654-3210FEDCB000} - The default GUID for appended Polygons in shapefiles.
- ShapePolyAltitude= 0 - The default altitude for appended Polygons in shapefiles.
- ShapePolyColor=140000FF - The default colour for appended Polygons in shapefiles.
- AddToCells=True - If set to False, Shp2Vec will replace default terrain elements with those of your scenery. If set to True, Shp2Vec will add them to the default scenery.

[Tiles]
- ActiveTileFolder=GoogleSatellite - The default tile server in the Edit-Preferences menu.
- ReprojectMercatorTiles=True - If set to True, SBuilderX will reproject image server tiles to Geographic projection.
- SummerVariations=July,August,September
- SpringVariations=April,May,June
- FallVariations=October,November
- WinterVariations=December,February,March
- HardWinterVariations=January
 You can set the months when your photo-real scenery should display seasonal variants.
 - CompressionQuality=85 - Change the compression quality for photo-real scenery to another value.

[BLN]
- BLNSeparator=, - This is the separator used between fields in BLN files.
- BLNPolyGuid={47D48287-3ADE-4FC5-8BEC-B6B36901E612} - The default GUID for appended Polygons in BLN files.
- BLNPolyColor=FFFF0000 - The default colour for appended Polygons in BLN files.
- BLNLineGuid={42E70A8E-6A7D-4279-9A0C-2AE9C2FCFD16} - The default GUID for appended Lines in BLN files.
- BLNLineColor=FFFFFF00 - The default colour for appended Lines in BLN files.
- BLNIsPolyAlt=True - Interpret 3rd parameter, if present, as Polygon altitude.
- BLNIsLineAlt=True - Interpret 3rd parameter, if present, as Line altitude.
- BLNStartWidth= 5 - The default value for the starting width of appended Lines in BLN files.
- BLNEndWidth= 5 - The default value for the end width of appended Lines in BLN files.
- BLNLineFromPoly=True - Make a Line from appended Polygons in BLN files
- BLNExportAltitudes=True - Include altitudes of Lines and Polygons when exporting to BLN files.


Appendix - Generic Building Texture Sets

This table indicates the textures that best match each other. To use, simply read across on the same line.

GENERIC TEXTURE SETS | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Primary colors | 0 | 0 | White | 0 | White | 1000 | White | 1000 | White
 | 1 | 1 | White |  |  |  |  |  |
 | 2 | 2 | Red | 1 | Red | 1001 | Red | 1001 | Red
 | 3 | 3 | Red |  |  |  |  |  |
 | 4 | 4 | Green | 2 | Green | 1002 | Green | 1002 | Green
 | 5 | 5 | Green |  |  |  |  |  |
 | 6 | 6 | Blue | 3 | Blue | 1003 | Blue | 1003 | Blue
 | 7 | 7 | Blue |  |  |  |  |  |
 | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Apartment buildings British | 8 | 8 | br_apt1_2 | 5 | br_apt2w | 1005 | br_apt2w | 1005 | br_apt2w
 | 9 | 9 | br_apt1_2 | 4 | br_apt1w | 1004 | br_apt1w | 1004 | br_apt1w
 | 10 | 10 | br_apt3_4 | 7 | br_apt4w | 1007 | br_apt4w | 1007 | br_apt4w
 | 11 | 11 | br_apt3_4 | 6 | br_apt3w | 1006 | br_apt3w | 1006 | br_apt3w
 | 12 | 12 | br_apt5_6 | 9 | br_apt6w | 1009 | br_apt6w | 1009 | br_apt6w
 | 13 | 13 | br_apt5_6 | 8 | br_apt5w | 1008 | br_apt5w | 1008 | br_apt5w
Apartment buildings French | 14 | 14 | fr_apt1_2 | 11 | fr_apt2w | 1011 | fr_apt2w | 1011 | fr_apt2w
 | 15 | 15 | fr_apt1_2 | 10 | fr_apt1w | 1010 | fr_apt1w | 1010 | fr_apt1w
 | 16 | 16 | fr_apt3_4 | 13 | fr_apt4w | 1013 | fr_apt4w | 1013 | fr_apt4w
 | 17 | 17 | fr_apt3_4 | 12 | fr_apt3w | 1012 | fr_apt3w | 1012 | fr_apt3w
Apartment buildings German | 18 | 18 | gr_apt1_2 | 15 | gr_apt2w | 1015 | gr_apt2w | 1015 | gr_apt2w
 | 19 | 19 | gr_apt1_2 | 14 | gr_apt1w | 1014 | gr_apt1w | 1014 | gr_apt1w
 | 20 | 20 | gr_apt3_4 | 17 | gr_apt4w | 1017 | gr_apt4w | 1017 | gr_apt4w
 | 21 | 21 | gr_apt3_4 | 16 | gr_apt3w | 1016 | gr_apt3w | 1016 | gr_apt3w
 | 22 | 22 | gr_apt5_6 | 19 | gr_apt6w | 1019 | gr_apt6w | 1019 | gr_apt6w
 | 23 | 23 | gr_apt5_6 | 18 | gr_apt5w | 1018 | gr_apt5w | 1018 | gr_apt5w
Apartment buildings default | 24 | 24 | ap_tb1_2 | 20 | ap_w1 | 1020 | ap_w1 | 1020 | ap_w1
 | 25 | 25 | ap_tb1_2 | 21 | ap_w2 | 1021 | ap_w2 | 1021 | ap_w2
 | 26 | 26 | ap_tb3_4 | 22 | ap_w3 | 1022 | ap_w3 | 1022 | ap_w3
 | 27 | 27 | ap_tb3_4 | 23 | ap_w4 | 1023 | ap_w4 | 1023 | ap_w4
 | 28 | 28 | ap_tb5_6 | 75 | ap_w7 | 1075 | ap_w7 | 1075 | ap_w7
 | 29 | 29 | ap_tb5_6 | 75 | ap_w7 | 1075 | ap_w7 | 1075 | ap_w7
 |  |  |  | 24 | ap_w5 | 1024 | ap_w5 | 1024 | ap_w5
 |  |  |  | 25 | ap_w6 | 1025 | ap_w6 | 1025 | ap_w6
 | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Generic government buildings | 30 | 30 | gv_tb1_2 | 26 | gv_w1 | 1026 | gv_w1 | 1026 | gv_w1
 | 31 | 31 | gv_tb1_2 | 27 | gv_w2 | 1027 | gv_w2 | 1027 | gv_w2
 | 32 | 32 | gv_tb3_4 |  |  |  |  |  |
 | 33 | 33 | gv_tb3_4 | 28 | gv_w3 | 1028 | gv_w3 | 1028 | gv_w3
 | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Generic warehouses | 34 | 35 | wh_tb1_2 | 29 | wh_w1 | 1029 | wh_w1 | 1029 | wh_w1
 | 35 | 34 | wh_tb1_2 | 29 | wh_w1 | 1029 | wh_w1 | 1029 | wh_w1
 | 36 | 37 | wh_tb3_4 |  |  |  |  |  |
 | 37 | 36 | wh_tb3_4 | 32 | wh_w4 | 1032 | wh_w4 | 1032 | wh_w4
 |  |  |  | 30 | wh_w2 | 1030 | wh_w2 | 1030 | wh_w2
 |  |  |  | 31 | wh_w3 | 1031 | wh_w3 | 1031 | wh_w3
 |  |  |  | 33 | wh_w5 | 1033 | wh_w5 | 1033 | wh_w5
 |  |  |  | 34 | wh_w6 | 1034 | wh_w6 | 1034 | wh_w6
 | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Generic skyscrapers - black | 38 | 38 | sky_tb_black1_2 | 35 | sky_w_black1 | 1035 | sky_w_black1 | 1035 | sky_w_black1
 | 39 | 39 | sky_tb_black1_2 | 36 | sky_w_black2 | 1036 | sky_w_black2 | 1036 | sky_w_black2
 | 40 | 40 | sky_tb_black3_4 | 37 | sky_w_black3 | 1037 | sky_w_black3 | 1037 | sky_w_black3
 | 41 | 41 | sky_tb_black3_4 | 76 | sky_w_black4 | 1076 | sky_w_black4 | 1076 | sky_w_black4
 |  |  |  | 77 | sky_w_black5 | 1077 | sky_w_black5 | 1077 | sky_w_black5
blue | 42 | 42 | sky_tb_blue1_2 | 38 | sky_w_blue1 | 1038 | sky_w_blue1 | 1038 | sky_w_blue1
 | 43 | 43 | sky_tb_blue1_2 | 39 | sky_w_blue2 | 1039 | sky_w_blue2 | 1039 | sky_w_blue2
 | 44 | 44 | sky_tb_blue3_4 | 40 | sky_w_blue3 | 1040 | sky_w_blue3 | 1040 | sky_w_blue3
 | 45 | 45 | sky_tb_blue3_4 | 78 | sky_w_blue4 | 1078 | sky_w_blue4 | 1078 | sky_w_blue4
dark gray | 46 | 46 | sky_tb_dkgray1_2 | 41 | sky_w_dkgray1 | 1041 | sky_w_dkgray1 | 1041 | sky_w_dkgray1
 | 47 | 47 | sky_tb_dkgray1_2 | 42 | sky_w_dkgray2 | 1042 | sky_w_dkgray2 | 1042 | sky_w_dkgray2
 | 48 | 48 | sky_tb_dkgray3_4 | 43 | sky_w_dkgray3 | 1043 | sky_w_dkgray3 | 1043 | sky_w_dkgray3
 | 49 | 49 | sky_tb_dkgray3_4 | 79 | sky_w_dkgray4 | 1079 | sky_w_dkgray4 | 1079 | sky_w_dkgray4
light gray | 50 | 50 | sky_tb_ltgray1_2 | 44 | sky_w_ltgray1 | 1044 | sky_w_ltgray1 | 1044 | sky_w_ltgray1
 | 51 | 51 | sky_tb_ltgray1_2 | 45 | sky_w_ltgray2 | 1045 | sky_w_ltgray2 | 1045 | sky_w_ltgray2
 | 52 | 52 | sky_tb_ltgray3_4 | 46 | sky_w_ltgray3 | 1046 | sky_w_ltgray3 | 1046 | sky_w_ltgray3
 | 53 | 53 | sky_tb_ltgray3_4 | 47 | sky_w_ltgray4 | 1047 | sky_w_ltgray4 | 1047 | sky_w_ltgray4
mid gray | 54 | 54 | sky_tb_midgray1_2 | 48 | sky_w_midgray1 | 1048 | sky_w_midgray1 | 1048 | sky_w_midgray1
 | 55 | 55 | sky_tb_midgray1_2 | 49 | sky_w_midgray2 | 1049 | sky_w_midgray2 | 1049 | sky_w_midgray2
 | 56 | 56 | sky_tb_midgray3_4 | 50 | sky_w_midgray3 | 1050 | sky_w_midgray3 | 1050 | sky_w_midgray3
 | 57 | 57 | sky_tb_midgray3_4 | 80 | sky_w_midgray4 | 1080 | sky_w_midgray4 | 1080 | sky_w_midgray4
 |  |  |  | 81 | sky_w_midgray5 | 1081 | sky_w_midgray5 | 1081 | sky_w_midgray5
 |  |  |  | 82 | sky_w_midgray6 | 1082 | sky_w_midgray6 | 1082 | sky_w_midgray6
red | 58 | 58 | sky_tb_red1_2 | 51 | sky_w_red1 | 1051 | sky_w_red1 | 1051 | sky_w_red1
 | 59 | 59 | sky_tb_red1_2 | 52 | sky_w_red2 | 1052 | sky_w_red2 | 1052 | sky_w_red2
 | 60 | 60 | sky_tb_red3_4 | 53 | sky_w_red3 | 1053 | sky_w_red3 | 1053 | sky_w_red3
 | 61 | 61 | sky_tb_red3_4 | 53 | sky_w_red3 | 1053 | sky_w_red3 | 1053 | sky_w_red3
tan | 62 | 62 | sky_tb_tan1_2 | 54 | sky_w_tan1 | 1054 | sky_w_tan1 | 1054 | sky_w_tan1
 | 63 | 63 | sky_tb_tan1_2 | 55 | sky_w_tan2 | 1055 | sky_w_tan2 | 1055 | sky_w_tan2
 | 64 | 64 | sky_tb_tan3_4 | 56 | sky_w_tan3 | 1056 | sky_w_tan3 | 1056 | sky_w_tan3
 | 65 | 65 | sky_tb_tan3_4 | 83 | sky_w_tan4 | 1083 | sky_w_tan4 | 1083 | sky_w_tan4
 | 84 | 84 | sky_tb_tan5_6 | 83 | sky_w_tan4 | 1083 | sky_w_tan4 | 1083 | sky_w_tan4
 | 85 | 85 | sky_tb_tan5_6 | 83 | sky_w_tan4 | 1083 | sky_w_tan4 | 1083 | sky_w_tan4
white | 66 | 66 | sky_tb_white1_2 | 57 | sky_w_white1 | 1057 | sky_w_white1 | 1057 | sky_w_white1
 | 67 | 67 | sky_tb_white1_2 | 58 | sky_w_white2 | 1058 | sky_w_white2 | 1058 | sky_w_white2
 | 68 | 68 | sky_tb_white3_4 | 59 | sky_w_white3 | 1059 | sky_w_white3 | 1059 | sky_w_white3
 | 69 | 69 | sky_tb_white3_4 | 84 | sky_w_white4 | 1084 | sky_w_white4 | 1084 | sky_w_white4
 | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Generic airport buildings | 70 | 70 | air_tb1_2 |  |  |  |  |  |
 | 71 | 71 | air_tb1_2 |  |  |  |  |  |
 | 72 | 72 | air_tb3_4 |  |  |  |  |  |
 | 73 | 73 | air_tb3_4 |  |  |  |  |  |
 | 74 | 74 | air_tb5_6 |  |  |  |  |  |
 | 75 | 75 | air_tb5_6 |  |  |  |  |  |
 | 76 | 76 | air_tb7_8 |  |  |  |  |  |
 | 77 | 77 | air_tb7_8 |  |  |  |  |  |
 | 78 | 78 | air_tb9_10 | 69 | air_w10 | 1069 | air_w10 | 1069 | air_w10
 | 79 | 79 | air_tb9_10 |  |  |  |  |  |
 |  |  |  | 60 | air_w1 | 1060 | air_w1 | 1060 | air_w1
 |  |  |  | 61 | air_w2 | 1061 | air_w2 | 1061 | air_w2
 |  |  |  | 62 | air_w3 | 1062 | air_w3 | 1062 | air_w3
 |  |  |  | 63 | air_w4 | 1063 | air_w4 | 1063 | air_w4
 |  |  |  | 64 | air_w5 | 1064 | air_w5 | 1064 | air_w5
 |  |  |  | 65 | air_w6 | 1065 | air_w6 | 1065 | air_w6
 |  |  |  | 66 | air_w7 | 1066 | air_w7 | 1066 | air_w7
 |  |  |  | 67 | air_w8 | 1067 | air_w8 | 1067 | air_w8
 |  |  |  | 68 | air_w9 | 1068 | air_w9 | 1068 | air_w9
 | Bottom | Top | Texture | Window | Texture | Gable | Texture | Face | Texture
Generic bank buildings | 80 | 80 | ba_tb1_2 |  |  |  |  |  |
 | 81 | 81 | ba_tb1_2 | 70 | ba_w1 | 1070 | ba_w1 | 1070 | ba_w1
 | 82 | 82 | ba_tb3_4 | 71 | ba_w2 | 1071 | ba_w2 | 1071 | ba_w2
 | 83 | 83 | ba_tb3_4 | 72 | ba_w3 | 1072 | ba_w3 | 1072 | ba_w3
 |  |  |  | 73 | ba_w4 | 1073 | ba_w4 | 1073 | ba_w4
 |  |  |  | 74 | ba_w5 | 1074 | ba_w5 | 1074 | ba_w5
 | Bottom |  | Texture | Window | Texture | Gable | Texture |  |
small airport terminals | 86 |  | SmallAirport | 85 | SmallAirport | 1085 | SmallAirport |  |
 | 87 |  | SmallAirport | 85 | SmallAirport | 1085 | SmallAirport |  |
 | 92 |  | SmallAirport | 88 | SmallAirport | 1088 | SmallAirport |  |
 | 93 |  | SmallAirport | 88 | SmallAirport | 1088 | SmallAirport |  |
 | 98 |  | SmallAirport | 91 | SmallAirport | 1091 | SmallAirport |  |
 | 99 |  | SmallAirport | 91 | SmallAirport | 1091 | SmallAirport |  |
 | 104 |  | SmallAirport | 94 | SmallAirport | 1094 | SmallAirport |  |
 | 105 |  | SmallAirport | 94 | SmallAirport | 1094 | SmallAirport |  |
 | 110 |  | SmallAirport | 97 | SmallAirport | 1097 | SmallAirport |  |
 | 111 |  | SmallAirport | 97 | SmallAirport | 1097 | SmallAirport |  |
 | 116 |  | SmallAirport | 100 | SmallAirport | 1100 | SmallAirport |  |
 | 117 |  | SmallAirport | 100 | SmallAirport | 1100 | SmallAirport |  |
 | Bottom |  | Texture | Window | Texture | Gable | Texture |  |
medium airport terminals | 88 |  | MediumAirport | 86 | MediumAirport | 1086 | MediumAirport |  |
 | 89 |  | MediumAirport | 86 | MediumAirport | 1086 | MediumAirport |  |
 | 94 |  | MediumAirport | 89 | MediumAirport | 1089 | MediumAirport |  |
 | 95 |  | MediumAirport | 89 | MediumAirport | 1089 | MediumAirport |  |
 | 100 |  | MediumAirport | 92 | MediumAirport | 1092 | MediumAirport |  |
 | 101 |  | MediumAirport | 92 | MediumAirport | 1092 | MediumAirport |  |
 | 106 |  | MediumAirport | 95 | MediumAirport | 1095 | MediumAirport |  |
 | 107 |  | MediumAirport | 95 | MediumAirport | 1095 | MediumAirport |  |
 | 112 |  | MediumAirport | 98 | MediumAirport | 1098 | MediumAirport |  |
 | 113 |  | MediumAirport | 98 | MediumAirport | 1098 | MediumAirport |  |
 | 118 |  | MediumAirport | 101 | MediumAirport | 1101 | MediumAirport |  |
 | 119 |  | MediumAirport | 101 | MediumAirport | 1101 | MediumAirport |  |
 | Bottom |  | Texture | Window | Texture | Gable | Texture |  |
large airport terminals | 90 |  | LargeAirport | 87 | LargeAirport | 1087 | LargeAirport |  |
 | 91 |  | LargeAirport | 87 | LargeAirport | 1087 | LargeAirport |  |
 | 96 |  | LargeAirport | 90 | LargeAirport | 1090 | LargeAirport |  |
 | 97 |  | LargeAirport | 90 | LargeAirport | 1090 | LargeAirport |  |
 | 102 |  | LargeAirport | 93 | LargeAirport | 1093 | LargeAirport |  |
 | 103 |  | LargeAirport | 93 | LargeAirport | 1093 | LargeAirport |  |
 | 108 |  | LargeAirport | 96 | LargeAirport | 1096 | LargeAirport |  |
 | 109 |  | LargeAirport | 96 | LargeAirport | 1096 | LargeAirport |  |
 | 114 |  | LargeAirport | 99 | LargeAirport | 1099 | LargeAirport |  |
 | 115 |  | LargeAirport | 99 | LargeAirport | 1099 | LargeAirport |  |
 | 120 |  | LargeAirport | 102 | LargeAirport | 1102 | LargeAirport |  |
 | 121 |  | LargeAirport | 102 | LargeAirport | 1102 | LargeAirport |  |
 |  |  |  | Window |  |  |  |  |
parking garage |  |  |  | 103 | ParkingGarage |  |  |  |
 |  |  |  | 104 | ParkingGarage |  |  |  |
 | Bottom |  | Texture | Window | Texture | Gable | Texture |  |
small hangar | 122 |  | AirportHangars_Small | 105 | AirportHangars_Small | 1105 | AirportHangars_Small |  |
 | 123 |  | AirportHangars_Small | 105 | AirportHangars_Small | 1105 | AirportHangars_Small |  |
 | 128 |  | AirportHangars_Small | 108 | AirportHangars_Small | 1108 | AirportHangars_Small |  |
 | 129 |  | AirportHangars_Small | 108 | AirportHangars_Small | 1108 | AirportHangars_Small |  |
 | 134 |  | AirportHangars_Small | 111 | AirportHangars_Small | 1111 | AirportHangars_Small |  |
 | 135 |  | AirportHangars_Small | 111 | AirportHangars_Small | 1111 | AirportHangars_Small |  |
 | 140 |  | AirportHangars_Small | 114 | AirportHangars_Small | 1114 | AirportHangars_Small |  |
 | 141 |  | AirportHangars_Small | 114 | AirportHangars_Small | 1114 | AirportHangars_Small |  |
 | 146 |  | AirportHangars_Small | 117 | AirportHangars_Small | 1117 | AirportHangars_Small |  |
 | 147 |  | AirportHangars_Small | 117 | AirportHangars_Small | 1117 | AirportHangars_Small |  |
 | Bottom |  | Texture | Window | Texture | Gable | Texture |  |
medium hangar | 124 |  | AirportHangars_Medium | 106 | AirportHangars_Medium | 1106 | AirportHangars_Medium |  |
 | 125 |  | AirportHangars_Medium | 106 | AirportHangars_Medium | 1106 | AirportHangars_Medium |  |
 | 130 |  | AirportHangars_Medium | 109 | AirportHangars_Medium | 1109 | AirportHangars_Medium |  |
 | 131 |  | AirportHangars_Medium | 109 | AirportHangars_Medium | 1109 | AirportHangars_Medium |  |
 | 136 |  | AirportHangars_Medium | 112 | AirportHangars_Medium | 1112 | AirportHangars_Medium |  |
 | 137 |  | AirportHangars_Medium | 112 | AirportHangars_Medium | 1112 | AirportHangars_Medium |  |
 | 142 |  | AirportHangars_Medium | 115 | AirportHangars_Medium | 1115 | AirportHangars_Medium |  |
 | 143 |  | AirportHangars_Medium | 115 | AirportHangars_Medium | 1115 | AirportHangars_Medium |  |
 | 148 |  | AirportHangars_Medium | 118 | AirportHangars_Medium | 1118 | AirportHangars_Medium |  |
 | 149 |  | AirportHangars_Medium | 118 | AirportHangars_Medium | 1118 | AirportHangars_Medium |  |
 | Bottom |  | Texture | Window | Texture | Gable | Texture |  |
large hangar | 126 |  | AirportHangars_Large | 107 | AirportHangars_Large | 1107 | AirportHangars_Large |  |
 | 127 |  | AirportHangars_Large | 107 | AirportHangars_Large | 1107 | AirportHangars_Large |  |
 | 132 |  | AirportHangars_Large | 110 | AirportHangars_Large | 1110 | AirportHangars_Large |  |
 | 133 |  | AirportHangars_Large | 110 | AirportHangars_Large | 1110 | AirportHangars_Large |  |
 | 138 |  | AirportHangars_Large | 113 | AirportHangars_Large | 1113 | AirportHangars_Large |  |
 | 139 |  | AirportHangars_Large | 113 | AirportHangars_Large | 1113 | AirportHangars_Large |  |
 | 144 |  | AirportHangars_Large | 116 | AirportHangars_Large | 1116 | AirportHangars_Large |  |
 | 145 |  | AirportHangars_Large | 116 | AirportHangars_Large | 1116 | AirportHangars_Large |  |
 | 150 |  | AirportHangars_Large | 119 | AirportHangars_Large | 1119 | AirportHangars_Large |  |
 | 151 |  | AirportHangars_Large | 119 | AirportHangars_Large | 1119 | AirportHangars_Large |  |
Roof | 0 |  | White |  |  |  |  |  |
 | 1 |  | Red |  |  |  |  |  |
 | 2 |  | Green |  |  |  |  |  |
 | 3 |  | Blue |  |  |  |  |  |
 | 4 |  | roof1 |  |  |  |  |  |
 | 5 |  | roof2 |  |  |  |  |  |
 | 6 |  | roof3 |  |  |  |  |  |
 | 7 |  | roof4 |  |  |  |  |  |
 | 8 |  | roof5 |  |  |  |  |  |
 | 9 |  | flatroof_1 |  |  |  |  |  |
 | 10 |  | flatroof_2 |  |  |  |  |  |
 | 11 |  | flatroof_3 |  |  |  |  |  |
 | 12 |  | flatroof_4 |  |  |  |  |  |
 | 13 |  | flatroof_5 |  |  |  |  |  |
 | 14 |  | flatroof_6 |  |  |  |  |  |
 | 15 |  | flatroof_7 |  |  |  |  |  |
 | 16 |  | flatroof_8 |  |  |  |  |  |
 | 17 |  | tileroof_1 |  |  |  |  |  |
 | 18 |  | tileroof_2 |  |  |  |  |  |
 | 19 |  | tileroof_3 |  |  |  |  |  |
 | 20 |  | tileroof_4 |  |  |  |  |  |
 | 21 |  | tileroof_5 |  |  |  |  |  |
 | 22 |  | blueroof |  |  |  |  |  |
 | 23 |  | blueroof2 |  |  |  |  |  |
 | 24 |  | blueroof3 |  |  |  |  |  |
 | 25 |  | dkgray |  |  |  |  |  |
 | 26 |  | dkgrayroof |  |  |  |  |  |
 | 27 |  | dkgrayroof3 |  |  |  |  |  |
 | 28 |  | ltgrayroof |  |  |  |  |  |
 | 29 |  | ltgrayroof2 |  |  |  |  |  |
 | 30 |  | mdgrayroof |  |  |  |  |  |
 | 31 |  | tanroof |  |  |  |  |  |
 | 32 |  | tanroof2 |  |  |  |  |  |
 | 33 |  | tanroof3 |  |  |  |  |  |
 | 34 |  | lightgravelroof |  |  |  |  |  |
 | 35 |  | darkgravelroof |  |  |  |  |  |
 | 36 |  | shingleroof |  |  |  |  |  |
 | 37 |  | corrugatedroof |  |  |  |  |  |